package ic;

import jdsl.core.ref.*;
import jdsl.core.api.*;
import jv.vecmath.*;

public class ArchimedeanSolids {
  public ArchimedeanSolids() {
    super();
  }

  public static Face generateTruncatedTetrahedron(){
  double dihedralAngle01 = PlatonicSolids.REGULAR_TETRAHEDRON;
  double dihedralAngle02 =Math.PI-821*Math.PI/1350; //Dihedral angles between polygons with 3 and 6 sides

  Face octahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.HEXAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  octahedronTree.replaceElement(octahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a raiz
  Face subFace01 = new Face(Face.HEXAGON,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle01, 1);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a raiz
  Face subFace02 = new Face(Face.TRIANGLE,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle02, 2);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface me
  Face subFace03 = new Face(Face.HEXAGON,subFace00.getVertex(3),subFace00.getVertex(2),dihedralAngle01, 3);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.TRIANGLE,subFace03.getVertex(4), subFace03.getVertex(3),dihedralAngle02, 4);
  tmp = octahedronTree.returnPositionFace(3,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a raiz
  Face subFace05 = new Face(Face.TRIANGLE,subFace00.getVertex(4),subFace00.getVertex(3),dihedralAngle02, 5);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 0
  Face subFace06 = new Face(Face.HEXAGON,subFace00.getVertex(5), subFace00.getVertex(4),dihedralAngle01, 6);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 0
  Face subFace07 = new Face(Face.TRIANGLE,subFace00.getVertex(0),subFace00.getVertex(5),dihedralAngle02, 7);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace07);

  return octahedronTree;
  }

  public static Face generateCuboctahedron(){
  double dihedralAngle = Math.PI-1879*Math.PI/2700;

  Face cuboctahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.SQUARE,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle, 0);
  cuboctahedronTree.replaceElement(cuboctahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a raiz
  Face subFace01 = new Face(Face.TRIANGLE,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle, 1);
  tmp = cuboctahedronTree.returnPositionFace(0,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.SQUARE,subFace01.getVertex(2),subFace01.getVertex(1),dihedralAngle, 2);
  tmp = cuboctahedronTree.returnPositionFace(1,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.TRIANGLE,subFace02.getVertex(3),subFace02.getVertex(2),dihedralAngle, 3);
  tmp = cuboctahedronTree.returnPositionFace(2,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.SQUARE,subFace03.getVertex(0), subFace03.getVertex(2),dihedralAngle, 4);
  tmp = cuboctahedronTree.returnPositionFace(3,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.TRIANGLE,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle, 5);
  tmp = cuboctahedronTree.returnPositionFace(0,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 05
  Face subFace06 = new Face(Face.SQUARE,subFace05.getVertex(2), subFace05.getVertex(1),dihedralAngle, 6);
  tmp = cuboctahedronTree.returnPositionFace(5,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.TRIANGLE,subFace06.getVertex(3),subFace06.getVertex(2),dihedralAngle, 7);
  tmp = cuboctahedronTree.returnPositionFace(6,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 06
  Face subFace08 = new Face(Face.TRIANGLE,subFace06.getVertex(0),subFace06.getVertex(3),dihedralAngle, 8);
  tmp = cuboctahedronTree.returnPositionFace(6,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a raiz (subaface 0)
  Face subFace09 = new Face(Face.TRIANGLE,subFace00.getVertex(3), subFace00.getVertex(2),dihedralAngle, 9);
  tmp = cuboctahedronTree.returnPositionFace(0,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.SQUARE,subFace09.getVertex(2), subFace09.getVertex(1),dihedralAngle, 10);
  tmp = cuboctahedronTree.returnPositionFace(9,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 10
  Face subFace11 = new Face(Face.TRIANGLE,subFace10.getVertex(0), subFace10.getVertex(3),dihedralAngle, 11);
  tmp = cuboctahedronTree.returnPositionFace(10,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 0
  Face subFace12 = new Face(Face.TRIANGLE,subFace00.getVertex(0),subFace00.getVertex(3),dihedralAngle, 12);
  tmp = cuboctahedronTree.returnPositionFace(0,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.SQUARE,subFace12.getVertex(2),subFace12.getVertex(1),dihedralAngle, 13);
  tmp = cuboctahedronTree.returnPositionFace(12,cuboctahedronTree);
  cuboctahedronTree.insertLastChild(tmp,subFace13);

  return cuboctahedronTree;
  }

  public static Face generateTruncatedCube(){
  double dihedralAngle01 = Math.PI/2;
  double dihedralAngle02 = Math.PI-1879*Math.PI/2700; //Dihedral angle between polygons with 3 and 8 sides

  Face truncatedCubeTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.OCTAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  truncatedCubeTree.replaceElement(truncatedCubeTree.root(),subFace00);

  //Insere a face 01 cuja me  a raiz
  Face subFace01 = new Face(Face.OCTAGON,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle01, 1);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.TRIANGLE,subFace01.getVertex(6),subFace01.getVertex(5),dihedralAngle02, 2);
  tmp = truncatedCubeTree.returnPositionFace(1,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 01
  Face subFace03 = new Face(Face.OCTAGON,subFace01.getVertex(5),subFace01.getVertex(4),dihedralAngle01, 3);
  tmp = truncatedCubeTree.returnPositionFace(1,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 0
  Face subFace04 = new Face(Face.TRIANGLE,subFace00.getVertex(0), subFace00.getVertex(7),dihedralAngle02, 4);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 0
  Face subFace05 = new Face(Face.OCTAGON,subFace00.getVertex(7),subFace00.getVertex(6),dihedralAngle01, 5);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 05
  Face subFace06 = new Face(Face.TRIANGLE,subFace05.getVertex(6), subFace05.getVertex(5),dihedralAngle02, 6);
  tmp = truncatedCubeTree.returnPositionFace(5,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 0
  Face subFace07 = new Face(Face.TRIANGLE,subFace00.getVertex(6),subFace00.getVertex(5),dihedralAngle02, 7);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 0
  Face subFace08 = new Face(Face.OCTAGON,subFace00.getVertex(5),subFace00.getVertex(4),dihedralAngle01, 8);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.TRIANGLE,subFace08.getVertex(6), subFace08.getVertex(5),dihedralAngle02, 9);
  tmp = truncatedCubeTree.returnPositionFace(8,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 0
  Face subFace10 = new Face(Face.TRIANGLE,subFace00.getVertex(4), subFace00.getVertex(3),dihedralAngle02, 10);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 0
  Face subFace11 = new Face(Face.OCTAGON,subFace00.getVertex(3), subFace00.getVertex(2),dihedralAngle01, 11);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 11
  Face subFace12 = new Face(Face.TRIANGLE,subFace11.getVertex(6),subFace11.getVertex(5),dihedralAngle02, 12);
  tmp = truncatedCubeTree.returnPositionFace(11,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 0
  Face subFace13 = new Face(Face.TRIANGLE,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle02, 13);
  tmp = truncatedCubeTree.returnPositionFace(0,truncatedCubeTree);
  truncatedCubeTree.insertLastChild(tmp,subFace13);

  return truncatedCubeTree;
  }

  public static Face generateTruncatedOctahedron(){
  double dihedralAngle01 = Math.PI-821*Math.PI/1350; //Dihedral angle between polygons with 6 and 6 sides
  double dihedralAngle02 = Math.PI-1879*Math.PI/2700; //Dihedral angle between polygons with 4 and 6 sides

  Face truncatedOctahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.HEXAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle02, 0);
  truncatedOctahedronTree.replaceElement(truncatedOctahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a raiz
  Face subFace01 = new Face(Face.SQUARE,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle02, 1);
  tmp = truncatedOctahedronTree.returnPositionFace(0,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.HEXAGON,subFace01.getVertex(3),subFace01.getVertex(2),dihedralAngle02, 2);
  tmp = truncatedOctahedronTree.returnPositionFace(1,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.HEXAGON,subFace02.getVertex(4),subFace02.getVertex(3),dihedralAngle01, 3);
  tmp = truncatedOctahedronTree.returnPositionFace(2,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 0
  Face subFace04 = new Face(Face.HEXAGON,subFace00.getVertex(0), subFace00.getVertex(5),dihedralAngle01, 4);
  tmp = truncatedOctahedronTree.returnPositionFace(0,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.SQUARE,subFace04.getVertex(4),subFace04.getVertex(3),dihedralAngle02, 5);
  tmp = truncatedOctahedronTree.returnPositionFace(4,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 0
  Face subFace06 = new Face(Face.SQUARE,subFace00.getVertex(5), subFace00.getVertex(4),dihedralAngle02, 6);
  tmp = truncatedOctahedronTree.returnPositionFace(0,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.HEXAGON,subFace06.getVertex(3),subFace06.getVertex(2),dihedralAngle02, 7);
  tmp = truncatedOctahedronTree.returnPositionFace(6,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 0
  Face subFace08 = new Face(Face.HEXAGON,subFace00.getVertex(4),subFace00.getVertex(3),dihedralAngle01, 8);
  tmp = truncatedOctahedronTree.returnPositionFace(0,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.SQUARE,subFace08.getVertex(4), subFace08.getVertex(3),dihedralAngle02, 9);
  tmp = truncatedOctahedronTree.returnPositionFace(8,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 0
  Face subFace10 = new Face(Face.SQUARE,subFace00.getVertex(3), subFace00.getVertex(2),dihedralAngle02, 10);
  tmp = truncatedOctahedronTree.returnPositionFace(0,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 10
  Face subFace11 = new Face(Face.HEXAGON,subFace10.getVertex(3), subFace10.getVertex(2),dihedralAngle02, 11);
  tmp = truncatedOctahedronTree.returnPositionFace(10,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 0
  Face subFace12 = new Face(Face.HEXAGON,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle01, 12);
  tmp = truncatedOctahedronTree.returnPositionFace(0,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.SQUARE,subFace12.getVertex(4),subFace12.getVertex(3),dihedralAngle02, 13);
  tmp = truncatedOctahedronTree.returnPositionFace(12,truncatedOctahedronTree);
  truncatedOctahedronTree.insertLastChild(tmp,subFace13);

  return truncatedOctahedronTree;
  }


  public static Face generateRhombicuboctahedron(){
  double dihedralAngle01 = Math.PI-3.0/4.0*Math.PI;//Dihedral angle between polygons with 4 and 4 sides
  double dihedralAngle02 = Math.PI-2171*Math.PI/2700; //Dihedral angle between polygons with 3 and 4 sides

  Face RhombicuboctahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.SQUARE,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  RhombicuboctahedronTree.replaceElement(RhombicuboctahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.SQUARE,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle01, 1);
  tmp = RhombicuboctahedronTree.returnPositionFace(0,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.SQUARE,subFace01.getVertex(3),subFace01.getVertex(2),dihedralAngle01, 2);
  tmp = RhombicuboctahedronTree.returnPositionFace(1,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.SQUARE,subFace02.getVertex(3),subFace02.getVertex(2),dihedralAngle01, 3);
  tmp = RhombicuboctahedronTree.returnPositionFace(2,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.SQUARE,subFace03.getVertex(3), subFace03.getVertex(2),dihedralAngle01, 4);
  tmp = RhombicuboctahedronTree.returnPositionFace(3,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.TRIANGLE,subFace04.getVertex(0),subFace04.getVertex(3),dihedralAngle02, 5);
  tmp = RhombicuboctahedronTree.returnPositionFace(4,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 02
  Face subFace06 = new Face(Face.TRIANGLE,subFace02.getVertex(2), subFace02.getVertex(1),dihedralAngle02, 6);
  tmp = RhombicuboctahedronTree.returnPositionFace(2,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.SQUARE,subFace06.getVertex(0),subFace06.getVertex(2),dihedralAngle02, 7);
  tmp = RhombicuboctahedronTree.returnPositionFace(6,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 01
  Face subFace08 = new Face(Face.SQUARE,subFace01.getVertex(2),subFace01.getVertex(1),dihedralAngle01, 8);
  tmp = RhombicuboctahedronTree.returnPositionFace(1,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.SQUARE,subFace08.getVertex(3), subFace08.getVertex(2),dihedralAngle01, 9);
  tmp = RhombicuboctahedronTree.returnPositionFace(8,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.SQUARE,subFace09.getVertex(3), subFace09.getVertex(2),dihedralAngle01, 10);
  tmp = RhombicuboctahedronTree.returnPositionFace(9,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 10
  Face subFace11 = new Face(Face.TRIANGLE,subFace10.getVertex(0), subFace10.getVertex(3),dihedralAngle02, 11);
  tmp = RhombicuboctahedronTree.returnPositionFace(10,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 00
  Face subFace12 = new Face(Face.SQUARE,subFace00.getVertex(3),subFace00.getVertex(2),dihedralAngle01, 12);
  tmp = RhombicuboctahedronTree.returnPositionFace(0,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.SQUARE,subFace12.getVertex(3),subFace12.getVertex(2),dihedralAngle01, 13);
  tmp = RhombicuboctahedronTree.returnPositionFace(12,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 13
  Face subFace14 = new Face(Face.SQUARE,subFace13.getVertex(3),subFace13.getVertex(2),dihedralAngle01, 14);
  tmp = RhombicuboctahedronTree.returnPositionFace(13,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 12
  Face subFace15 = new Face(Face.SQUARE,subFace12.getVertex(2),subFace12.getVertex(1),dihedralAngle01, 15);
  tmp = RhombicuboctahedronTree.returnPositionFace(12,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 15
  Face subFace16 = new Face(Face.TRIANGLE,subFace15.getVertex(0),subFace15.getVertex(3),dihedralAngle02, 16);
  tmp = RhombicuboctahedronTree.returnPositionFace(15,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 00
  Face subFace17 = new Face(Face.TRIANGLE,subFace00.getVertex(0),subFace00.getVertex(3),dihedralAngle02, 17);
  tmp = RhombicuboctahedronTree.returnPositionFace(0,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 17
  Face subFace18 = new Face(Face.SQUARE,subFace17.getVertex(2),subFace17.getVertex(1),dihedralAngle02, 18);
  tmp = RhombicuboctahedronTree.returnPositionFace(17,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.TRIANGLE,subFace18.getVertex(3),subFace18.getVertex(2),dihedralAngle02, 19);
  tmp = RhombicuboctahedronTree.returnPositionFace(18,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 00
  Face subFace20 = new Face(Face.TRIANGLE,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle02, 20);
  tmp = RhombicuboctahedronTree.returnPositionFace(0,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 20
  Face subFace21 = new Face(Face.SQUARE,subFace20.getVertex(2),subFace20.getVertex(1),dihedralAngle02, 21);
  tmp = RhombicuboctahedronTree.returnPositionFace(20,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 21
  Face subFace22 = new Face(Face.TRIANGLE,subFace21.getVertex(3),subFace21.getVertex(2),dihedralAngle02, 22);
  tmp = RhombicuboctahedronTree.returnPositionFace(21,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 22
  Face subFace23 = new Face(Face.SQUARE,subFace22.getVertex(0),subFace22.getVertex(2),dihedralAngle02, 23);
  tmp = RhombicuboctahedronTree.returnPositionFace(22,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 21
  Face subFace24 = new Face(Face.SQUARE,subFace21.getVertex(0),subFace21.getVertex(3),dihedralAngle01, 24);
  tmp = RhombicuboctahedronTree.returnPositionFace(21,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 24
  Face subFace25 = new Face(Face.SQUARE,subFace24.getVertex(3),subFace24.getVertex(2),dihedralAngle01, 25);
  tmp = RhombicuboctahedronTree.returnPositionFace(24,RhombicuboctahedronTree);
  RhombicuboctahedronTree.insertLastChild(tmp,subFace25);

  return RhombicuboctahedronTree;

  }

  public static Face generateRhombiTruncatedCuboctahedron(){
  double dihedralAngle01 = Math.PI-2171*Math.PI/2700;//Dihedral angle between polygons with 4 and 6 sides
  double dihedralAngle02 = Math.PI-3.0/4.0*Math.PI; //Dihedral angle between polygons with 4 and 8 sides
  double dihedralAngle03 = Math.PI-1879*Math.PI/2700; //Dihedral angle between polygons with 6 and 8 sides

  Face RhombiTruncatedCuboctahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.OCTAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  RhombiTruncatedCuboctahedronTree.replaceElement(RhombiTruncatedCuboctahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.HEXAGON,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle03, 1);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.SQUARE,subFace01.getVertex(4),subFace01.getVertex(3),dihedralAngle01, 2);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(1,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.HEXAGON,subFace02.getVertex(3),subFace02.getVertex(2),dihedralAngle01, 3);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(2,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.OCTAGON,subFace03.getVertex(4), subFace03.getVertex(3),dihedralAngle03, 4);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(3,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 00
  Face subFace05 = new Face(Face.SQUARE,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle02, 5);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 05
  Face subFace06 = new Face(Face.OCTAGON,subFace05.getVertex(3), subFace05.getVertex(2),dihedralAngle02, 6);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(5,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.SQUARE,subFace06.getVertex(5),subFace06.getVertex(4),dihedralAngle02, 7);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(6,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 06
  Face subFace08 = new Face(Face.HEXAGON,subFace06.getVertex(6),subFace06.getVertex(5),dihedralAngle03, 8);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(6,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 00
  Face subFace09 = new Face(Face.HEXAGON,subFace00.getVertex(3), subFace00.getVertex(2),dihedralAngle03, 9);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.SQUARE,subFace09.getVertex(4), subFace09.getVertex(3),dihedralAngle01, 10);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(9,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 00
  Face subFace11 = new Face(Face.SQUARE,subFace00.getVertex(4), subFace00.getVertex(3),dihedralAngle02, 11);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 11
  Face subFace12 = new Face(Face.OCTAGON,subFace11.getVertex(3),subFace11.getVertex(2),dihedralAngle02, 12);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(11,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.SQUARE,subFace12.getVertex(5),subFace12.getVertex(4),dihedralAngle02, 13);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(12,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 12
  Face subFace14 = new Face(Face.HEXAGON,subFace12.getVertex(6),subFace12.getVertex(5),dihedralAngle03, 14);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(12,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 00
  Face subFace15 = new Face(Face.HEXAGON,subFace00.getVertex(5),subFace00.getVertex(4),dihedralAngle03, 15);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 15
  Face subFace16 = new Face(Face.SQUARE,subFace15.getVertex(4),subFace15.getVertex(3),dihedralAngle01, 16);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(15,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 00
  Face subFace17 = new Face(Face.SQUARE,subFace00.getVertex(6),subFace00.getVertex(5),dihedralAngle02, 17);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 17
  Face subFace18 = new Face(Face.OCTAGON,subFace17.getVertex(3),subFace17.getVertex(2),dihedralAngle02, 18);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(17,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.SQUARE,subFace18.getVertex(5),subFace18.getVertex(4),dihedralAngle02, 19);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(18,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 00
  Face subFace20 = new Face(Face.HEXAGON,subFace00.getVertex(7),subFace00.getVertex(6),dihedralAngle03, 20);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 20
  Face subFace21 = new Face(Face.SQUARE,subFace20.getVertex(4),subFace20.getVertex(3),dihedralAngle01, 21);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(20,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 00
  Face subFace22 = new Face(Face.SQUARE,subFace00.getVertex(0),subFace00.getVertex(7),dihedralAngle02, 22);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(0,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 22
  Face subFace23 = new Face(Face.OCTAGON,subFace22.getVertex(3),subFace22.getVertex(2),dihedralAngle02, 23);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(22,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 23
  Face subFace24 = new Face(Face.SQUARE,subFace23.getVertex(5),subFace23.getVertex(4),dihedralAngle02, 24);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(23,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 23
  Face subFace25 = new Face(Face.HEXAGON,subFace23.getVertex(4),subFace23.getVertex(3),dihedralAngle03, 25);
  tmp = RhombiTruncatedCuboctahedronTree.returnPositionFace(23,RhombiTruncatedCuboctahedronTree);
  RhombiTruncatedCuboctahedronTree.insertLastChild(tmp,subFace25);

  return RhombiTruncatedCuboctahedronTree;

  }


  public static Face generateRhombiTruncatedIcosidodecahedron(){
  double dihedralAngle01 = Math.PI-1591*Math.PI/1800;//Dihedral angle between polygons with 4 and 6 sides
  double dihedralAngle02 = Math.PI-8897*Math.PI/10800; //Dihedral angle between polygons with 4 and 10 sides
  double dihedralAngle03 = Math.PI-8557*Math.PI/10800; //Dihedral angle between polygons with 6 and 10 sides

  Face rhombiTruncatedIcosidodecahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.DECAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  rhombiTruncatedIcosidodecahedronTree.replaceElement(rhombiTruncatedIcosidodecahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.SQUARE,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle02, 1);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.DECAGON,subFace01.getVertex(3),subFace01.getVertex(2),dihedralAngle02, 2);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(1,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.SQUARE,subFace02.getVertex(5),subFace02.getVertex(4),dihedralAngle02, 3);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(2,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.DECAGON,subFace03.getVertex(3), subFace03.getVertex(2),dihedralAngle02, 4);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(3,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.HEXAGON,subFace04.getVertex(6),subFace04.getVertex(5),dihedralAngle03, 5);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(4,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 05
  Face subFace06 = new Face(Face.DECAGON,subFace05.getVertex(5), subFace05.getVertex(4),dihedralAngle03, 6);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(5,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 04
  Face subFace07 = new Face(Face.SQUARE,subFace04.getVertex(7),subFace04.getVertex(6),dihedralAngle02, 7);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(4,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 02
  Face subFace08 = new Face(Face.HEXAGON,subFace02.getVertex(6),subFace02.getVertex(5),dihedralAngle03, 8);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(2,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.SQUARE, subFace08.getVertex(4), subFace08.getVertex(3),dihedralAngle01, 9);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(8,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.HEXAGON,subFace09.getVertex(3), subFace09.getVertex(2),dihedralAngle01, 10);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(9,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 02
  Face subFace11 = new Face(Face.SQUARE,subFace02.getVertex(7), subFace02.getVertex(6),dihedralAngle02, 11);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(2,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 11
  Face subFace12 = new Face(Face.DECAGON,subFace11.getVertex(3),subFace11.getVertex(2),dihedralAngle02, 12);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(11,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.SQUARE,subFace12.getVertex(5),subFace12.getVertex(4),dihedralAngle02, 13);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(12,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 12
  Face subFace14 = new Face(Face.HEXAGON,subFace12.getVertex(6),subFace12.getVertex(5),dihedralAngle03, 14);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(12,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 00
  Face subFace15 = new Face(Face.HEXAGON,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle03, 15);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 15
  Face subFace16 = new Face(Face.SQUARE,subFace15.getVertex(4),subFace15.getVertex(3),dihedralAngle01, 16);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(15,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 16
  Face subFace17 = new Face(Face.HEXAGON,subFace16.getVertex(3), subFace16.getVertex(2),dihedralAngle01, 17);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(16,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 00
  Face subFace18 = new Face(Face.SQUARE, subFace00.getVertex(3), subFace00.getVertex(2), dihedralAngle02, 18);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.DECAGON,subFace18.getVertex(3),subFace18.getVertex(2),dihedralAngle02, 19);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(18,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 19
  Face subFace20 = new Face(Face.SQUARE, subFace19.getVertex(5), subFace19.getVertex(4), dihedralAngle02, 20);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(19, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 19
  Face subFace21 = new Face(Face.HEXAGON, subFace19.getVertex(6),subFace19.getVertex(5),dihedralAngle03, 21);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(19,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 21
  Face subFace22 = new Face(Face.SQUARE,subFace21.getVertex(4),subFace21.getVertex(3),dihedralAngle01, 22);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(21,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 19
  Face subFace23 = new Face(Face.SQUARE,subFace19.getVertex(7),subFace19.getVertex(6),dihedralAngle02, 23);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(19,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 23
  Face subFace24 = new Face(Face.DECAGON, subFace23.getVertex(3),subFace23.getVertex(2),dihedralAngle02, 24);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(23,rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 24
  Face subFace25 = new Face(Face.SQUARE, subFace24.getVertex(5), subFace24.getVertex(4), dihedralAngle02, 25);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(24, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace25);

  //Insere a face 26 cuja me  a subface 24
  Face subFace26 = new Face(Face.HEXAGON, subFace24.getVertex(6), subFace24.getVertex(5), dihedralAngle03, 26);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(24, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace26);

  //Insere a face 27 cuja me  a subface 00
  Face subFace27 = new Face(Face.HEXAGON, subFace00.getVertex(4), subFace00.getVertex(3), dihedralAngle03, 27);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace27);

  //Insere a face 28 cuja me  a subface 27
  Face subFace28 = new Face(Face.SQUARE, subFace27.getVertex(4), subFace27.getVertex(3), dihedralAngle01, 28);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(27, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace28);

  //Insere a face 29 cuja me  a subface 28
  Face subFace29 = new Face(Face.HEXAGON, subFace28.getVertex(3), subFace28.getVertex(2), dihedralAngle01, 29);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(28, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace29);

  //Insere a face 30 cuja me  a subface 00
  Face subFace30 = new Face(Face.SQUARE, subFace00.getVertex(5), subFace00.getVertex(4), dihedralAngle02, 30);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(00, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace30);

  //Insere a face 31 cuja me  a subface 30
  Face subFace31 = new Face(Face.DECAGON, subFace30.getVertex(3), subFace30.getVertex(2), dihedralAngle02, 31);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(30, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace31);

  //Insere a face 32 cuja me  a subface 31
  Face subFace32 = new Face(Face.SQUARE, subFace31.getVertex(5), subFace31.getVertex(4), dihedralAngle02, 32);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(31, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace32);

  //Insere a face 33 cuja me  a subface 31
  Face subFace33 = new Face(Face.HEXAGON, subFace31.getVertex(6), subFace31.getVertex(5), dihedralAngle03, 33);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(31, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace33);

  //Insere a face 34 cuja me  a subface 33
  Face subFace34 = new Face(Face.SQUARE, subFace33.getVertex(4), subFace33.getVertex(3), dihedralAngle01, 34);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(33, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace34);

  //Insere a face 35 cuja me  a subface 31
  Face subFace35 = new Face(Face.SQUARE, subFace31.getVertex(7), subFace31.getVertex(6), dihedralAngle02, 35);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(31, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace35);

  //Insere a face 36 cuja me  a subface 35
  Face subFace36 = new Face(Face.DECAGON, subFace35.getVertex(3), subFace35.getVertex(2), dihedralAngle02, 36);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(35, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace36);

  //Insere a face 37 cuja me  a subface 36
  Face subFace37 = new Face(Face.SQUARE, subFace36.getVertex(5), subFace36.getVertex(4), dihedralAngle02, 37);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(36, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace37);

  //Insere a face 38 cuja me  a subface 36
  Face subFace38 = new Face(Face.HEXAGON, subFace36.getVertex(6), subFace36.getVertex(5), dihedralAngle03, 38);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(36, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace38);

  //Insere a face 39 cuja me  a subface 00
  Face subFace39 = new Face(Face.HEXAGON, subFace00.getVertex(6), subFace00.getVertex(5), dihedralAngle03, 39);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace39);

  //Insere a face 40 cuja me  a subface 39
  Face subFace40 = new Face(Face.SQUARE, subFace39.getVertex(4), subFace39.getVertex(3), dihedralAngle01, 40);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(39, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace40);

  //Insere a face 41 cuja me  a subface 40
  Face subFace41 = new Face(Face.HEXAGON, subFace40.getVertex(3), subFace40.getVertex(2), dihedralAngle01, 41);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(40, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace41);

  //Insere a face 42 cuja me  a subface 00
  Face subFace42 = new Face(Face.SQUARE, subFace00.getVertex(7), subFace00.getVertex(6), dihedralAngle02, 42);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace42);

  //Insere a face 43 cuja me  a subface 42
  Face subFace43 = new Face(Face.DECAGON, subFace42.getVertex(3), subFace42.getVertex(2), dihedralAngle02, 43);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(42, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace43);

  //Insere a face 44 cuja me  a subface 43
  Face subFace44 = new Face(Face.SQUARE, subFace43.getVertex(7), subFace43.getVertex(6), dihedralAngle02, 44);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(43, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace44);

  //Insere a face 45 cuja me  a subface 44
  Face subFace45 = new Face(Face.DECAGON, subFace44.getVertex(3), subFace44.getVertex(2), dihedralAngle02, 45);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(44, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace45);

  //Insere a face 46 cuja me  a subface 45
  Face subFace46 = new Face(Face.SQUARE, subFace45.getVertex(5), subFace45.getVertex(4), dihedralAngle02, 46);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(45, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace46);

  //Insere a face 47 cuja me  a subface 43
  Face subFace47 = new Face(Face.HEXAGON, subFace43.getVertex(6), subFace43.getVertex(5), dihedralAngle03, 47);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(43, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace47);

  //Insere a face 48 cuja me  a subface 47
  Face subFace48 = new Face(Face.SQUARE, subFace47.getVertex(4), subFace47.getVertex(3), dihedralAngle01, 48);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(47, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace48);

  //Insere a face 49 cuja me  a subface 43
  Face subFace49 = new Face(Face.SQUARE, subFace43.getVertex(5), subFace43.getVertex(4), dihedralAngle02, 49);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(43, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace49);

  //Insere a face 50 cuja me  a subface 00
  Face subFace50 = new Face(Face.HEXAGON, subFace00.getVertex(8), subFace00.getVertex(7), dihedralAngle03, 50);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace50);

  //Insere a face 51 cuja me  a subface 50
  Face subFace51 = new Face(Face.SQUARE, subFace50.getVertex(4), subFace50.getVertex(3), dihedralAngle01, 51);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(50, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace51);

  //Insere a face 52 cuja me  a subface 51
  Face subFace52 = new Face(Face.HEXAGON, subFace51.getVertex(3), subFace51.getVertex(2), dihedralAngle01, 52);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(51, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace52);

  //Insere a face 53 cuja me  a subface 00
  Face subFace53 = new Face(Face.SQUARE, subFace00.getVertex(9), subFace00.getVertex(8), dihedralAngle02, 53);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace53);

  //Insere a face 54 cuja me  a subface 53
  Face subFace54 = new Face(Face.DECAGON, subFace53.getVertex(3), subFace53.getVertex(2), dihedralAngle02, 54);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(53, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace54);

  //Insere a face 55 cuja me  a subface 54
  Face subFace55 = new Face(Face.SQUARE, subFace54.getVertex(5), subFace54.getVertex(4), dihedralAngle02, 55);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(54, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace55);

  //Insere a face 56 cuja me  a subface 54
  Face subFace56 = new Face(Face.HEXAGON, subFace54.getVertex(6), subFace54.getVertex(5), dihedralAngle03, 56);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(54, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace56);

  //Insere a face 57 cuja me  a subface 56
  Face subFace57 = new Face(Face.SQUARE, subFace56.getVertex(4), subFace56.getVertex(3), dihedralAngle01, 57);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(56, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace57);

  //Insere a face 58 cuja me  a subface 54
  Face subFace58 = new Face(Face.SQUARE, subFace54.getVertex(7), subFace54.getVertex(6), dihedralAngle02, 58);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(54, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace58);

  //Insere a face 59 cuja me  a subface 00
  Face subFace59 = new Face(Face.HEXAGON, subFace00.getVertex(0), subFace00.getVertex(9), dihedralAngle03, 59);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(0, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace59);

  //Insere a face 60 cuja me  a subface 59
  Face subFace60 = new Face(Face.SQUARE, subFace59.getVertex(4), subFace59.getVertex(3), dihedralAngle01, 60);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(59, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace60);

  //Insere a face 61 cuja me  a subface 60
  Face subFace61 = new Face(Face.HEXAGON, subFace60.getVertex(3), subFace60.getVertex(2), dihedralAngle01, 61);
  tmp = rhombiTruncatedIcosidodecahedronTree.returnPositionFace(60, rhombiTruncatedIcosidodecahedronTree);
  rhombiTruncatedIcosidodecahedronTree.insertLastChild(tmp, subFace61);

  return rhombiTruncatedIcosidodecahedronTree;

  }


  public static Face generateIcosidodecahedron(){
  double dihedralAngle01 = Math.PI-8557*Math.PI/10800;//Dihedral angle between polygons with 3 and 5 sides

  Face icosidodecahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.PENTAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  icosidodecahedronTree.replaceElement(icosidodecahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.TRIANGLE,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle01, 1);
  tmp = icosidodecahedronTree.returnPositionFace(0,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.PENTAGON,subFace01.getVertex(2),subFace01.getVertex(1),dihedralAngle01, 2);
  tmp = icosidodecahedronTree.returnPositionFace(1,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.TRIANGLE,subFace02.getVertex(3),subFace02.getVertex(2),dihedralAngle01, 3);
  tmp = icosidodecahedronTree.returnPositionFace(2,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.PENTAGON,subFace03.getVertex(0), subFace03.getVertex(2),dihedralAngle01, 4);
  tmp = icosidodecahedronTree.returnPositionFace(3,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.TRIANGLE,subFace04.getVertex(3),subFace04.getVertex(2),dihedralAngle01, 5);
  tmp = icosidodecahedronTree.returnPositionFace(4,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 05
  Face subFace06 = new Face(Face.PENTAGON,subFace05.getVertex(0), subFace05.getVertex(2),dihedralAngle01, 6);
  tmp = icosidodecahedronTree.returnPositionFace(5,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 04
  Face subFace07 = new Face(Face.TRIANGLE,subFace04.getVertex(4),subFace04.getVertex(3),dihedralAngle01, 7);
  tmp = icosidodecahedronTree.returnPositionFace(4,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 02
  Face subFace08 = new Face(Face.TRIANGLE,subFace02.getVertex(4), subFace02.getVertex(3),dihedralAngle01, 8);
  tmp = icosidodecahedronTree.returnPositionFace(2,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.PENTAGON, subFace08.getVertex(0), subFace08.getVertex(2),dihedralAngle01, 9);
  tmp = icosidodecahedronTree.returnPositionFace(8,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.TRIANGLE,subFace09.getVertex(3), subFace09.getVertex(2),dihedralAngle01, 10);
  tmp = icosidodecahedronTree.returnPositionFace(9,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 00
  Face subFace11 = new Face(Face.TRIANGLE,subFace00.getVertex(2), subFace00.getVertex(1),dihedralAngle01, 11);
  tmp = icosidodecahedronTree.returnPositionFace(0,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 11
  Face subFace12 = new Face(Face.PENTAGON,subFace11.getVertex(2),subFace11.getVertex(1),dihedralAngle01, 12);
  tmp = icosidodecahedronTree.returnPositionFace(11,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.TRIANGLE,subFace12.getVertex(3), subFace12.getVertex(2),dihedralAngle01, 13);
  tmp = icosidodecahedronTree.returnPositionFace(12,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 12
  Face subFace14 = new Face(Face.TRIANGLE,subFace12.getVertex(4),subFace12.getVertex(3),dihedralAngle01, 14);
  tmp = icosidodecahedronTree.returnPositionFace(12,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 14
  Face subFace15 = new Face(Face.PENTAGON,subFace14.getVertex(0), subFace14.getVertex(2),dihedralAngle01, 15);
  tmp = icosidodecahedronTree.returnPositionFace(14,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 15
  Face subFace16 = new Face(Face.TRIANGLE,subFace15.getVertex(3),subFace15.getVertex(2),dihedralAngle01, 16);
  tmp = icosidodecahedronTree.returnPositionFace(15,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 00
  Face subFace17 = new Face(Face.TRIANGLE,subFace00.getVertex(3), subFace00.getVertex(2),dihedralAngle01, 17);
  tmp = icosidodecahedronTree.returnPositionFace(0,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 17
  Face subFace18 = new Face(Face.PENTAGON, subFace17.getVertex(2), subFace17.getVertex(1), dihedralAngle01, 18);
  tmp = icosidodecahedronTree.returnPositionFace(17,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.TRIANGLE,subFace18.getVertex(3), subFace18.getVertex(2),dihedralAngle01, 19);
  tmp = icosidodecahedronTree.returnPositionFace(18,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 18
  Face subFace20 = new Face(Face.TRIANGLE, subFace18.getVertex(4), subFace18.getVertex(3), dihedralAngle01, 20);
  tmp = icosidodecahedronTree.returnPositionFace(18, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 20
  Face subFace21 = new Face(Face.PENTAGON, subFace20.getVertex(0),subFace20.getVertex(2),dihedralAngle01, 21);
  tmp = icosidodecahedronTree.returnPositionFace(20,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 21
  Face subFace22 = new Face(Face.TRIANGLE,subFace21.getVertex(3), subFace21.getVertex(2),dihedralAngle01, 22);
  tmp = icosidodecahedronTree.returnPositionFace(21,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 00
  Face subFace23 = new Face(Face.TRIANGLE,subFace00.getVertex(4),subFace00.getVertex(3),dihedralAngle01, 23);
  tmp = icosidodecahedronTree.returnPositionFace(0,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 23
  Face subFace24 = new Face(Face.PENTAGON, subFace23.getVertex(2), subFace23.getVertex(1),dihedralAngle01, 24);
  tmp = icosidodecahedronTree.returnPositionFace(23,icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 24
  Face subFace25 = new Face(Face.TRIANGLE, subFace24.getVertex(3), subFace24.getVertex(2), dihedralAngle01, 25);
  tmp = icosidodecahedronTree.returnPositionFace(24, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp, subFace25);

  //Insere a face 26 cuja me  a subface 24
  Face subFace26 = new Face(Face.TRIANGLE, subFace24.getVertex(4), subFace24.getVertex(3), dihedralAngle01, 26);
  tmp = icosidodecahedronTree.returnPositionFace(24, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp, subFace26);

  //Insere a face 27 cuja me  a subface 26
  Face subFace27 = new Face(Face.PENTAGON, subFace26.getVertex(0), subFace26.getVertex(2), dihedralAngle01, 27);
  tmp = icosidodecahedronTree.returnPositionFace(26, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp, subFace27);

  //Insere a face 28 cuja me  a subface 00
  Face subFace28 = new Face(Face.TRIANGLE, subFace00.getVertex(0), subFace00.getVertex(4), dihedralAngle01, 28);
  tmp = icosidodecahedronTree.returnPositionFace(0, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp, subFace28);

  //Insere a face 29 cuja me  a subface 28
  Face subFace29 = new Face(Face.PENTAGON, subFace28.getVertex(2), subFace28.getVertex(1), dihedralAngle01, 29);
  tmp = icosidodecahedronTree.returnPositionFace(28, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp, subFace29);

  //Insere a face 30 cuja me  a subface 29
  Face subFace30 = new Face(Face.TRIANGLE, subFace29.getVertex(3), subFace29.getVertex(2), dihedralAngle01, 30);
  tmp = icosidodecahedronTree.returnPositionFace(29, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp, subFace30);

  //Insere a face 31 cuja me  a subface 29
  Face subFace31 = new Face(Face.TRIANGLE, subFace29.getVertex(4), subFace29.getVertex(3), dihedralAngle01, 31);
  tmp = icosidodecahedronTree.returnPositionFace(29, icosidodecahedronTree);
  icosidodecahedronTree.insertLastChild(tmp, subFace31);

   return icosidodecahedronTree;

  }

  public static Face generateRhombicosidodecahedron(){
  double dihedralAngle01 = Math.PI-1591*Math.PI/1800;//Dihedral angle between polygons with 3 and 4 sides
  double dihedralAngle02 = Math.PI-8897*Math.PI/10800; //Dihedral angle between polygons with 4 and 5 sides


  Face rhombicosidodecahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.PENTAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  rhombicosidodecahedronTree.replaceElement(rhombicosidodecahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.SQUARE,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle02, 1);
  tmp = rhombicosidodecahedronTree.returnPositionFace(0,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.TRIANGLE,subFace01.getVertex(2),subFace01.getVertex(1),dihedralAngle01, 2);
  tmp = rhombicosidodecahedronTree.returnPositionFace(1,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.SQUARE,subFace02.getVertex(0),subFace02.getVertex(2),dihedralAngle01, 3);
  tmp = rhombicosidodecahedronTree.returnPositionFace(2,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.TRIANGLE,subFace03.getVertex(3), subFace03.getVertex(2),dihedralAngle01, 4);
  tmp = rhombicosidodecahedronTree.returnPositionFace(3,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 01
  Face subFace05 = new Face(Face.PENTAGON,subFace01.getVertex(3),subFace01.getVertex(2),dihedralAngle02, 5);
  tmp = rhombicosidodecahedronTree.returnPositionFace(1,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 05
  Face subFace06 = new Face(Face.SQUARE,subFace05.getVertex(3), subFace05.getVertex(2),dihedralAngle02, 6);
  tmp = rhombicosidodecahedronTree.returnPositionFace(5,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.PENTAGON,subFace06.getVertex(3),subFace06.getVertex(2),dihedralAngle02, 7);
  tmp = rhombicosidodecahedronTree.returnPositionFace(6, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 07
  Face subFace08 = new Face(Face.SQUARE,subFace07.getVertex(3),subFace07.getVertex(2),dihedralAngle02, 8);
  tmp = rhombicosidodecahedronTree.returnPositionFace(7, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.TRIANGLE, subFace08.getVertex(0), subFace08.getVertex(3),dihedralAngle01, 9);
  tmp = rhombicosidodecahedronTree.returnPositionFace(8,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 07
  Face subFace10 = new Face(Face.SQUARE,subFace07.getVertex(4), subFace07.getVertex(3),dihedralAngle02, 10);
  tmp = rhombicosidodecahedronTree.returnPositionFace(7,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 10
  Face subFace11 = new Face(Face.PENTAGON,subFace10.getVertex(3), subFace10.getVertex(2),dihedralAngle02, 11);
  tmp = rhombicosidodecahedronTree.returnPositionFace(10,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 05
  Face subFace12 = new Face(Face.SQUARE,subFace05.getVertex(4),subFace05.getVertex(3),dihedralAngle02, 12);
  tmp = rhombicosidodecahedronTree.returnPositionFace(5,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.TRIANGLE,subFace12.getVertex(2),subFace12.getVertex(1),dihedralAngle01, 13);
  tmp = rhombicosidodecahedronTree.returnPositionFace(12,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 13
  Face subFace14 = new Face(Face.SQUARE,subFace13.getVertex(0),subFace13.getVertex(2),dihedralAngle01, 14);
  tmp = rhombicosidodecahedronTree.returnPositionFace(13,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 14
  Face subFace15 = new Face(Face.TRIANGLE,subFace14.getVertex(3),subFace14.getVertex(2),dihedralAngle01, 15);
  tmp = rhombicosidodecahedronTree.returnPositionFace(14,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 00
  Face subFace16 = new Face(Face.SQUARE,subFace00.getVertex(2),subFace00.getVertex(1),dihedralAngle02, 16);
  tmp = rhombicosidodecahedronTree.returnPositionFace(0,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 16
  Face subFace17 = new Face(Face.TRIANGLE,subFace16.getVertex(2), subFace16.getVertex(1),dihedralAngle01, 17);
  tmp = rhombicosidodecahedronTree.returnPositionFace(16,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 17
  Face subFace18 = new Face(Face.SQUARE, subFace17.getVertex(0), subFace17.getVertex(2), dihedralAngle01, 18);
  tmp = rhombicosidodecahedronTree.returnPositionFace(17,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.TRIANGLE,subFace18.getVertex(3),subFace18.getVertex(2),dihedralAngle01, 19);
  tmp = rhombicosidodecahedronTree.returnPositionFace(18,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 16
  Face subFace20 = new Face(Face.PENTAGON, subFace16.getVertex(3), subFace16.getVertex(2), dihedralAngle02, 20);
  tmp = rhombicosidodecahedronTree.returnPositionFace(16, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 20
  Face subFace21 = new Face(Face.SQUARE, subFace20.getVertex(3),subFace20.getVertex(2),dihedralAngle02, 21);
  tmp = rhombicosidodecahedronTree.returnPositionFace(20,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 21
  Face subFace22 = new Face(Face.PENTAGON,subFace21.getVertex(3),subFace21.getVertex(2),dihedralAngle02, 22);
  tmp = rhombicosidodecahedronTree.returnPositionFace(21,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 22
  Face subFace23 = new Face(Face.SQUARE,subFace22.getVertex(4),subFace22.getVertex(3),dihedralAngle02, 23);
  tmp = rhombicosidodecahedronTree.returnPositionFace(22,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 23
  Face subFace24 = new Face(Face.TRIANGLE, subFace23.getVertex(0),subFace23.getVertex(3),dihedralAngle01, 24);
  tmp = rhombicosidodecahedronTree.returnPositionFace(23,rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 20
  Face subFace25 = new Face(Face.SQUARE, subFace20.getVertex(4), subFace20.getVertex(3), dihedralAngle02, 25);
  tmp = rhombicosidodecahedronTree.returnPositionFace(20, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace25);

  //Insere a face 26 cuja me  a subface 25
  Face subFace26 = new Face(Face.TRIANGLE, subFace25.getVertex(2), subFace25.getVertex(1), dihedralAngle01, 26);
  tmp = rhombicosidodecahedronTree.returnPositionFace(25, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace26);

  //Insere a face 27 cuja me  a subface 26
  Face subFace27 = new Face(Face.SQUARE, subFace26.getVertex(0), subFace26.getVertex(2), dihedralAngle01, 27);
  tmp = rhombicosidodecahedronTree.returnPositionFace(26, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace27);

  //Insere a face 28 cuja me  a subface 00
  Face subFace28 = new Face(Face.SQUARE, subFace00.getVertex(3), subFace00.getVertex(2), dihedralAngle02, 28);
  tmp = rhombicosidodecahedronTree.returnPositionFace(0, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace28);

  //Insere a face 29 cuja me  a subface 28
  Face subFace29 = new Face(Face.TRIANGLE, subFace28.getVertex(2), subFace28.getVertex(1), dihedralAngle01, 29);
  tmp = rhombicosidodecahedronTree.returnPositionFace(28, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace29);

  //Insere a face 30 cuja me  a subface 29
  Face subFace30 = new Face(Face.SQUARE, subFace29.getVertex(0), subFace29.getVertex(2), dihedralAngle01, 30);
  tmp = rhombicosidodecahedronTree.returnPositionFace(29, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace30);

  //Insere a face 31 cuja me  a subface 30
  Face subFace31 = new Face(Face.TRIANGLE, subFace30.getVertex(3), subFace30.getVertex(2), dihedralAngle01, 31);
  tmp = rhombicosidodecahedronTree.returnPositionFace(30, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace31);

  //Insere a face 32 cuja me  a subface 28
  Face subFace32 = new Face(Face.PENTAGON, subFace28.getVertex(3), subFace28.getVertex(2), dihedralAngle02, 32);
  tmp = rhombicosidodecahedronTree.returnPositionFace(28, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace32);

  //Insere a face 33 cuja me  a subface 32
  Face subFace33 = new Face(Face.SQUARE, subFace32.getVertex(3), subFace32.getVertex(2), dihedralAngle02, 33);
  tmp = rhombicosidodecahedronTree.returnPositionFace(32, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace33);

  //Insere a face 34 cuja me  a subface 33
  Face subFace34 = new Face(Face.PENTAGON, subFace33.getVertex(3), subFace33.getVertex(2), dihedralAngle02, 34);
  tmp = rhombicosidodecahedronTree.returnPositionFace(33, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace34);

  //Insere a face 35 cuja me  a subface 34
  Face subFace35 = new Face(Face.SQUARE, subFace34.getVertex(4), subFace34.getVertex(3), dihedralAngle02, 35);
  tmp = rhombicosidodecahedronTree.returnPositionFace(34, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace35);

  //Insere a face 36 cuja me  a subface 35
  Face subFace36 = new Face(Face.TRIANGLE, subFace35.getVertex(0), subFace35.getVertex(3), dihedralAngle01, 36);
  tmp = rhombicosidodecahedronTree.returnPositionFace(35, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace36);

  //Insere a face 37 cuja me  a subface 32
  Face subFace37 = new Face(Face.SQUARE, subFace32.getVertex(4), subFace32.getVertex(3), dihedralAngle02, 37);
  tmp = rhombicosidodecahedronTree.returnPositionFace(32, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace37);

  //Insere a face 38 cuja me  a subface 37
  Face subFace38 = new Face(Face.TRIANGLE, subFace37.getVertex(2), subFace37.getVertex(1), dihedralAngle01, 38);
  tmp = rhombicosidodecahedronTree.returnPositionFace(37, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace38);

  //Insere a face 39 cuja me  a subface 38
  Face subFace39 = new Face(Face.SQUARE, subFace38.getVertex(0), subFace38.getVertex(2), dihedralAngle01, 39);
  tmp = rhombicosidodecahedronTree.returnPositionFace(38, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace39);

  //Insere a face 40 cuja me  a subface 00
  Face subFace40 = new Face(Face.SQUARE, subFace00.getVertex(4), subFace00.getVertex(3), dihedralAngle02, 40);
  tmp = rhombicosidodecahedronTree.returnPositionFace(0, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace40);

  //Insere a face 41 cuja me  a subface 40
  Face subFace41 = new Face(Face.TRIANGLE, subFace40.getVertex(2), subFace40.getVertex(1), dihedralAngle01, 41);
  tmp = rhombicosidodecahedronTree.returnPositionFace(40, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace41);

  //Insere a face 42 cuja me  a subface 41
  Face subFace42 = new Face(Face.SQUARE, subFace41.getVertex(0), subFace41.getVertex(2), dihedralAngle01, 42);
  tmp = rhombicosidodecahedronTree.returnPositionFace(41, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace42);

  //Insere a face 43 cuja me  a subface 42
  Face subFace43 = new Face(Face.TRIANGLE, subFace42.getVertex(3), subFace42.getVertex(2), dihedralAngle01, 43);
  tmp = rhombicosidodecahedronTree.returnPositionFace(42, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace43);

  //Insere a face 44 cuja me  a subface 40
  Face subFace44 = new Face(Face.PENTAGON, subFace40.getVertex(3), subFace40.getVertex(2), dihedralAngle02, 44);
  tmp = rhombicosidodecahedronTree.returnPositionFace(40, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace44);

  //Insere a face 45 cuja me  a subface 44
  Face subFace45 = new Face(Face.SQUARE, subFace44.getVertex(3), subFace44.getVertex(2), dihedralAngle02, 45);
  tmp = rhombicosidodecahedronTree.returnPositionFace(44, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace45);

  //Insere a face 46 cuja me  a subface 45
  Face subFace46 = new Face(Face.PENTAGON, subFace45.getVertex(3), subFace45.getVertex(2), dihedralAngle02, 46);
  tmp = rhombicosidodecahedronTree.returnPositionFace(45, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace46);

  //Insere a face 47 cuja me  a subface 46
  Face subFace47 = new Face(Face.SQUARE, subFace46.getVertex(4), subFace46.getVertex(3), dihedralAngle02, 47);
  tmp = rhombicosidodecahedronTree.returnPositionFace(46, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace47);

  //Insere a face 48 cuja me  a subface 47
  Face subFace48 = new Face(Face.TRIANGLE, subFace47.getVertex(0), subFace47.getVertex(3), dihedralAngle01, 48);
  tmp = rhombicosidodecahedronTree.returnPositionFace(47, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace48);

  //Insere a face 49 cuja me  a subface 44
  Face subFace49 = new Face(Face.SQUARE, subFace44.getVertex(4), subFace44.getVertex(3), dihedralAngle02, 49);
  tmp = rhombicosidodecahedronTree.returnPositionFace(44, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace49);

  //Insere a face 50 cuja me  a subface 49
  Face subFace50 = new Face(Face.TRIANGLE, subFace49.getVertex(2), subFace49.getVertex(1), dihedralAngle01, 50);
  tmp = rhombicosidodecahedronTree.returnPositionFace(49, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace50);

  //Insere a face 51 cuja me  a subface 50
  Face subFace51 = new Face(Face.SQUARE, subFace50.getVertex(0), subFace50.getVertex(2), dihedralAngle01, 51);
  tmp = rhombicosidodecahedronTree.returnPositionFace(50, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace51);

  //Insere a face 52 cuja me  a subface 00
  Face subFace52 = new Face(Face.SQUARE, subFace00.getVertex(0), subFace00.getVertex(4), dihedralAngle02, 52);
  tmp = rhombicosidodecahedronTree.returnPositionFace(0, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace52);

  //Insere a face 53 cuja me  a subface 52
  Face subFace53 = new Face(Face.TRIANGLE, subFace52.getVertex(2), subFace52.getVertex(1), dihedralAngle01, 53);
  tmp = rhombicosidodecahedronTree.returnPositionFace(52, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace53);

  //Insere a face 54 cuja me  a subface 53
  Face subFace54 = new Face(Face.SQUARE, subFace53.getVertex(0), subFace53.getVertex(2), dihedralAngle01, 54);
  tmp = rhombicosidodecahedronTree.returnPositionFace(53, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace54);

  //Insere a face 55 cuja me  a subface 54
  Face subFace55 = new Face(Face.TRIANGLE, subFace54.getVertex(3), subFace54.getVertex(2), dihedralAngle01, 55);
  tmp = rhombicosidodecahedronTree.returnPositionFace(54, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace55);

  //Insere a face 56 cuja me  a subface 52
  Face subFace56 = new Face(Face.PENTAGON, subFace52.getVertex(3), subFace52.getVertex(2), dihedralAngle02, 56);
  tmp = rhombicosidodecahedronTree.returnPositionFace(52, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace56);

  //Insere a face 57 cuja me  a subface 56
  Face subFace57 = new Face(Face.SQUARE, subFace56.getVertex(4), subFace56.getVertex(3), dihedralAngle02, 57);
  tmp = rhombicosidodecahedronTree.returnPositionFace(56, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace57);

  //Insere a face 58 cuja me  a subface 57
  Face subFace58 = new Face(Face.TRIANGLE, subFace57.getVertex(2), subFace57.getVertex(1), dihedralAngle01, 58);
  tmp = rhombicosidodecahedronTree.returnPositionFace(57, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace58);

  //Insere a face 59 cuja me  a subface 56
  Face subFace59 = new Face(Face.SQUARE, subFace56.getVertex(3), subFace56.getVertex(2), dihedralAngle02, 59);
  tmp = rhombicosidodecahedronTree.returnPositionFace(56, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace59);

  //Insere a face 60 cuja me  a subface 59
  Face subFace60 = new Face(Face.PENTAGON, subFace59.getVertex(3), subFace59.getVertex(2), dihedralAngle02, 60);
  tmp = rhombicosidodecahedronTree.returnPositionFace(59, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace60);

  //Insere a face 61 cuja me  a subface 60
  Face subFace61 = new Face(Face.SQUARE, subFace60.getVertex(4), subFace60.getVertex(3), dihedralAngle02, 61);
  tmp = rhombicosidodecahedronTree.returnPositionFace(60, rhombicosidodecahedronTree);
  rhombicosidodecahedronTree.insertLastChild(tmp, subFace61);

  return rhombicosidodecahedronTree;

  }


  public static Face generateTruncatedDodecahedron(){
  double dihedralAngle01 = Math.PI-8557*Math.PI/10800;//Dihedral angle between polygons with 3 and 10 sides
  double dihedralAngle02 = Math.PI-3497*Math.PI/5400; //Dihedral angle between polygons with 10 and 10 sides

  Face truncatedDodecahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.DECAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  truncatedDodecahedronTree.replaceElement(truncatedDodecahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.DECAGON,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle02, 1);
  tmp = truncatedDodecahedronTree.returnPositionFace(0,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.TRIANGLE,subFace01.getVertex(4),subFace01.getVertex(3),dihedralAngle01, 2);
  tmp = truncatedDodecahedronTree.returnPositionFace(1,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 01
  Face subFace03 = new Face(Face.DECAGON, subFace01.getVertex(5),subFace01.getVertex(4),dihedralAngle02, 3);
  tmp = truncatedDodecahedronTree.returnPositionFace(1,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.TRIANGLE, subFace03.getVertex(6), subFace03.getVertex(5),dihedralAngle01, 4);
  tmp = truncatedDodecahedronTree.returnPositionFace(3,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 01
  Face subFace05 = new Face(Face.TRIANGLE, subFace01.getVertex(6), subFace01.getVertex(5),dihedralAngle01, 5);
  tmp = truncatedDodecahedronTree.returnPositionFace(1,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 00
  Face subFace06 = new Face(Face.TRIANGLE, subFace00.getVertex(2), subFace00.getVertex(1),dihedralAngle01, 6);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 00
  Face subFace07 = new Face(Face.DECAGON, subFace00.getVertex(3), subFace00.getVertex(2),dihedralAngle02, 7);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 07
  Face subFace08 = new Face(Face.TRIANGLE, subFace07.getVertex(4), subFace07.getVertex(3),dihedralAngle01, 8);
  tmp = truncatedDodecahedronTree.returnPositionFace(7, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 07
  Face subFace09 = new Face(Face.DECAGON, subFace07.getVertex(5), subFace07.getVertex(4),dihedralAngle02, 9);
  tmp = truncatedDodecahedronTree.returnPositionFace(7, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.TRIANGLE, subFace09.getVertex(6), subFace09.getVertex(5),dihedralAngle01, 10);
  tmp = truncatedDodecahedronTree.returnPositionFace(9, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 09
  Face subFace11 = new Face(Face.DECAGON, subFace09.getVertex(7), subFace09.getVertex(6),dihedralAngle02, 11);
  tmp = truncatedDodecahedronTree.returnPositionFace(9, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 07
  Face subFace12 = new Face(Face.TRIANGLE, subFace07.getVertex(6), subFace07.getVertex(5),dihedralAngle01, 12);
  tmp = truncatedDodecahedronTree.returnPositionFace(7,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 00
  Face subFace13 = new Face(Face.TRIANGLE, subFace00.getVertex(4), subFace00.getVertex(3),dihedralAngle01, 13);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 00
  Face subFace14 = new Face(Face.DECAGON, subFace00.getVertex(5), subFace00.getVertex(4), dihedralAngle02, 14);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 14
  Face subFace15 = new Face(Face.TRIANGLE, subFace14.getVertex(4), subFace14.getVertex(3),dihedralAngle01, 15);
  tmp = truncatedDodecahedronTree.returnPositionFace(14, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 14
  Face subFace16 = new Face(Face.DECAGON, subFace14.getVertex(5), subFace14.getVertex(4), dihedralAngle02, 16);
  tmp = truncatedDodecahedronTree.returnPositionFace(14, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 16
  Face subFace17 = new Face(Face.TRIANGLE, subFace16.getVertex(6), subFace16.getVertex(5), dihedralAngle01, 17);
  tmp = truncatedDodecahedronTree.returnPositionFace(16,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 16
  Face subFace18 = new Face(Face.TRIANGLE, subFace16.getVertex(8), subFace16.getVertex(7), dihedralAngle01, 18);
  tmp = truncatedDodecahedronTree.returnPositionFace(16, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 14
  Face subFace19 = new Face(Face.TRIANGLE, subFace14.getVertex(6), subFace14.getVertex(5), dihedralAngle01, 19);
  tmp = truncatedDodecahedronTree.returnPositionFace(14, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 00
  Face subFace20 = new Face(Face.TRIANGLE, subFace00.getVertex(6), subFace00.getVertex(5), dihedralAngle01, 20);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 00
  Face subFace21 = new Face(Face.DECAGON, subFace00.getVertex(7), subFace00.getVertex(6), dihedralAngle02, 21);
  tmp = truncatedDodecahedronTree.returnPositionFace(0,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 21
  Face subFace22 = new Face(Face.TRIANGLE, subFace21.getVertex(4), subFace21.getVertex(3), dihedralAngle01, 22);
  tmp = truncatedDodecahedronTree.returnPositionFace(21,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 21
  Face subFace23 = new Face(Face.DECAGON, subFace21.getVertex(5), subFace21.getVertex(4), dihedralAngle02, 23);
  tmp = truncatedDodecahedronTree.returnPositionFace(21,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 23
  Face subFace24 = new Face(Face.TRIANGLE, subFace23.getVertex(8), subFace23.getVertex(7), dihedralAngle01, 24);
  tmp = truncatedDodecahedronTree.returnPositionFace(23,truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 21
  Face subFace25 = new Face(Face.TRIANGLE, subFace21.getVertex(6), subFace21.getVertex(5), dihedralAngle01, 25);
  tmp = truncatedDodecahedronTree.returnPositionFace(21, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp, subFace25);

  //Insere a face 26 cuja me  a subface 00
  Face subFace26 = new Face(Face.TRIANGLE, subFace00.getVertex(8), subFace00.getVertex(7), dihedralAngle01, 26);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp, subFace26);

  //Insere a face 27 cuja me  a subface 00
  Face subFace27 = new Face(Face.DECAGON, subFace00.getVertex(9), subFace00.getVertex(8), dihedralAngle02, 27);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp, subFace27);

  //Insere a face 28 cuja me  a subface 27
  Face subFace28 = new Face(Face.TRIANGLE, subFace27.getVertex(4), subFace27.getVertex(3), dihedralAngle01, 28);
  tmp = truncatedDodecahedronTree.returnPositionFace(27, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp, subFace28);

  //Insere a face 29 cuja me  a subface 27
  Face subFace29 = new Face(Face.DECAGON, subFace27.getVertex(5), subFace27.getVertex(4), dihedralAngle02, 29);
  tmp = truncatedDodecahedronTree.returnPositionFace(27, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp, subFace29);

  //Insere a face 30 cuja me  a subface 27
  Face subFace30 = new Face(Face.TRIANGLE, subFace27.getVertex(6), subFace27.getVertex(5), dihedralAngle01, 30);
  tmp = truncatedDodecahedronTree.returnPositionFace(27, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp, subFace30);

  //Insere a face 31 cuja me  a subface 00
  Face subFace31 = new Face(Face.TRIANGLE, subFace00.getVertex(0), subFace00.getVertex(9), dihedralAngle01, 31);
  tmp = truncatedDodecahedronTree.returnPositionFace(0, truncatedDodecahedronTree);
  truncatedDodecahedronTree.insertLastChild(tmp, subFace31);

  return truncatedDodecahedronTree;

  }


  public static Face generateTruncatedIcosahedron(){
  double dihedralAngle01 = Math.PI-8557*Math.PI/10800;//Dihedral angle between polygons with 5 and 6 sides
  double dihedralAngle02 = Math.PI-8291*Math.PI/10800; //Dihedral angle between polygons with 6 and 6 sides

  Face truncatedIcosahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.HEXAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  truncatedIcosahedronTree.replaceElement(truncatedIcosahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.PENTAGON,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle01, 1);
  tmp = truncatedIcosahedronTree.returnPositionFace(0,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.HEXAGON, subFace01.getVertex(3), subFace01.getVertex(2), dihedralAngle01, 2);
  tmp = truncatedIcosahedronTree.returnPositionFace(1,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.HEXAGON, subFace02.getVertex(4), subFace02.getVertex(3),dihedralAngle02, 3);
  tmp = truncatedIcosahedronTree.returnPositionFace(2,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.PENTAGON, subFace03.getVertex(4), subFace03.getVertex(3), dihedralAngle01, 4);
  tmp = truncatedIcosahedronTree.returnPositionFace(3,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.HEXAGON, subFace04.getVertex(4), subFace04.getVertex(3), dihedralAngle01, 5);
  tmp = truncatedIcosahedronTree.returnPositionFace(4,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 00
  Face subFace06 = new Face(Face.HEXAGON, subFace00.getVertex(2), subFace00.getVertex(1), dihedralAngle02, 6);
  tmp = truncatedIcosahedronTree.returnPositionFace(0, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.HEXAGON, subFace06.getVertex(3), subFace06.getVertex(2), dihedralAngle02, 7);
  tmp = truncatedIcosahedronTree.returnPositionFace(6, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 07
  Face subFace08 = new Face(Face.PENTAGON, subFace07.getVertex(4), subFace07.getVertex(3), dihedralAngle01, 8);
  tmp = truncatedIcosahedronTree.returnPositionFace(7, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.HEXAGON, subFace08.getVertex(4), subFace08.getVertex(3), dihedralAngle01, 9);
  tmp = truncatedIcosahedronTree.returnPositionFace(8, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 07
  Face subFace10 = new Face(Face.HEXAGON, subFace07.getVertex(5), subFace07.getVertex(4), dihedralAngle02, 10);
  tmp = truncatedIcosahedronTree.returnPositionFace(7, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 10
  Face subFace11 = new Face(Face.PENTAGON, subFace10.getVertex(4), subFace10.getVertex(3), dihedralAngle01, 11);
  tmp = truncatedIcosahedronTree.returnPositionFace(10, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 06
  Face subFace12 = new Face(Face.PENTAGON, subFace06.getVertex(4), subFace06.getVertex(3), dihedralAngle01, 12);
  tmp = truncatedIcosahedronTree.returnPositionFace(6,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.HEXAGON, subFace12.getVertex(4), subFace12.getVertex(3), dihedralAngle01, 13);
  tmp = truncatedIcosahedronTree.returnPositionFace(12, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 13
  Face subFace14 = new Face(Face.HEXAGON, subFace13.getVertex(4), subFace13.getVertex(3), dihedralAngle02, 14);
  tmp = truncatedIcosahedronTree.returnPositionFace(13, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 00
  Face subFace15 = new Face(Face.PENTAGON, subFace00.getVertex(3), subFace00.getVertex(2), dihedralAngle01, 15);
  tmp = truncatedIcosahedronTree.returnPositionFace(0, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 15
  Face subFace16 = new Face(Face.HEXAGON, subFace15.getVertex(3), subFace15.getVertex(2), dihedralAngle01, 16);
  tmp = truncatedIcosahedronTree.returnPositionFace(15, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 16
  Face subFace17 = new Face(Face.PENTAGON, subFace16.getVertex(5), subFace16.getVertex(4), dihedralAngle01, 17);
  tmp = truncatedIcosahedronTree.returnPositionFace(16,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 00
  Face subFace18 = new Face(Face.HEXAGON, subFace00.getVertex(4), subFace00.getVertex(3), dihedralAngle02, 18);
  tmp = truncatedIcosahedronTree.returnPositionFace(0, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.HEXAGON, subFace18.getVertex(3), subFace18.getVertex(2), dihedralAngle02, 19);
  tmp = truncatedIcosahedronTree.returnPositionFace(18, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 19
  Face subFace20 = new Face(Face.HEXAGON, subFace19.getVertex(5), subFace19.getVertex(4), dihedralAngle02, 20);
  tmp = truncatedIcosahedronTree.returnPositionFace(19, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 20
  Face subFace21 = new Face(Face.PENTAGON, subFace20.getVertex(4), subFace20.getVertex(3), dihedralAngle01, 21);
  tmp = truncatedIcosahedronTree.returnPositionFace(20,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 18
  Face subFace22 = new Face(Face.PENTAGON, subFace18.getVertex(4), subFace18.getVertex(3), dihedralAngle01, 22);
  tmp = truncatedIcosahedronTree.returnPositionFace(18,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 22
  Face subFace23 = new Face(Face.HEXAGON, subFace22.getVertex(4), subFace22.getVertex(3), dihedralAngle01, 23);
  tmp = truncatedIcosahedronTree.returnPositionFace(22,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 23
  Face subFace24 = new Face(Face.HEXAGON, subFace23.getVertex(4), subFace23.getVertex(3), dihedralAngle02, 24);
  tmp = truncatedIcosahedronTree.returnPositionFace(23,truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 00
  Face subFace25 = new Face(Face.PENTAGON, subFace00.getVertex(5), subFace00.getVertex(4), dihedralAngle01, 25);
  tmp = truncatedIcosahedronTree.returnPositionFace(0, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp, subFace25);

  //Insere a face 26 cuja me  a subface 25
  Face subFace26 = new Face(Face.HEXAGON, subFace25.getVertex(3), subFace25.getVertex(2), dihedralAngle01, 26);
  tmp = truncatedIcosahedronTree.returnPositionFace(25, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp, subFace26);

  //Insere a face 27 cuja me  a subface 26
  Face subFace27 = new Face(Face.PENTAGON, subFace26.getVertex(5), subFace26.getVertex(4), dihedralAngle01, 27);
  tmp = truncatedIcosahedronTree.returnPositionFace(26, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp, subFace27);

  //Insere a face 28 cuja me  a subface 00
  Face subFace28 = new Face(Face.HEXAGON, subFace00.getVertex(0), subFace00.getVertex(5), dihedralAngle02, 28);
  tmp = truncatedIcosahedronTree.returnPositionFace(0, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp, subFace28);

  //Insere a face 29 cuja me  a subface 28
  Face subFace29 = new Face(Face.HEXAGON, subFace28.getVertex(3), subFace28.getVertex(2), dihedralAngle02, 29);
  tmp = truncatedIcosahedronTree.returnPositionFace(28, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp, subFace29);

  //Insere a face 30 cuja me  a subface 29
  Face subFace30 = new Face(Face.HEXAGON, subFace29.getVertex(5), subFace29.getVertex(4), dihedralAngle02, 30);
  tmp = truncatedIcosahedronTree.returnPositionFace(29, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp, subFace30);

  //Insere a face 31 cuja me  a subface 28
  Face subFace31 = new Face(Face.PENTAGON, subFace28.getVertex(4), subFace28.getVertex(3), dihedralAngle01, 31);
  tmp = truncatedIcosahedronTree.returnPositionFace(28, truncatedIcosahedronTree);
  truncatedIcosahedronTree.insertLastChild(tmp, subFace31);

  return truncatedIcosahedronTree;

  }

  public static Face generateSnubCuboctahedron(){
  double dihedralAngle01 = Math.PI-4597*Math.PI/5400;//Dihedral angle between polygons with 3 and 3 sides
  double dihedralAngle02 = Math.PI-8579*Math.PI/10800; //Dihedral angle between polygons with 3 and 4 sides

  Face snubCuboctahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.SQUARE,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  snubCuboctahedronTree.replaceElement(snubCuboctahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.TRIANGLE,subFace00.getVertex(1),subFace00.getVertex(0),dihedralAngle02, 1);
  tmp = snubCuboctahedronTree.returnPositionFace(0,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.TRIANGLE,subFace01.getVertex(2),subFace01.getVertex(1),dihedralAngle01, 2);
  tmp = snubCuboctahedronTree.returnPositionFace(1,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.TRIANGLE,subFace02.getVertex(0),subFace02.getVertex(2),dihedralAngle01, 3);
  tmp = snubCuboctahedronTree.returnPositionFace(2,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.TRIANGLE,subFace03.getVertex(2), subFace03.getVertex(1),dihedralAngle01, 4);
  tmp = snubCuboctahedronTree.returnPositionFace(3,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.TRIANGLE,subFace04.getVertex(0),subFace04.getVertex(2),dihedralAngle01, 5);
  tmp = snubCuboctahedronTree.returnPositionFace(4,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 01
  Face subFace06 = new Face(Face.TRIANGLE,subFace01.getVertex(0), subFace01.getVertex(2),dihedralAngle01, 6);
  tmp = snubCuboctahedronTree.returnPositionFace(1,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.SQUARE, subFace06.getVertex(2), subFace06.getVertex(1),dihedralAngle02, 7);
  tmp = snubCuboctahedronTree.returnPositionFace(6,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 07
  Face subFace08 = new Face(Face.TRIANGLE,subFace07.getVertex(3),subFace07.getVertex(2),dihedralAngle02, 8);
  tmp = snubCuboctahedronTree.returnPositionFace(7,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.TRIANGLE, subFace08.getVertex(0), subFace08.getVertex(2),dihedralAngle01, 9);
  tmp = snubCuboctahedronTree.returnPositionFace(8,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.SQUARE,subFace09.getVertex(2), subFace09.getVertex(1),dihedralAngle02, 10);
  tmp = snubCuboctahedronTree.returnPositionFace(9,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 00
  Face subFace11 = new Face(Face.TRIANGLE,subFace00.getVertex(2), subFace00.getVertex(1),dihedralAngle02, 11);
  tmp = snubCuboctahedronTree.returnPositionFace(0,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 11
  Face subFace12 = new Face(Face.TRIANGLE,subFace11.getVertex(2),subFace11.getVertex(1),dihedralAngle01, 12);
  tmp = snubCuboctahedronTree.returnPositionFace(11,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 12
  Face subFace13 = new Face(Face.TRIANGLE,subFace12.getVertex(0),subFace12.getVertex(2),dihedralAngle01, 13);
  tmp = snubCuboctahedronTree.returnPositionFace(12,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 13
  Face subFace14 = new Face(Face.TRIANGLE,subFace13.getVertex(2),subFace13.getVertex(1),dihedralAngle01, 14);
  tmp = snubCuboctahedronTree.returnPositionFace(13,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 14
  Face subFace15 = new Face(Face.TRIANGLE, subFace14.getVertex(0),subFace14.getVertex(2),dihedralAngle01, 15);
  tmp = snubCuboctahedronTree.returnPositionFace(14,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 11
  Face subFace16 = new Face(Face.TRIANGLE,subFace11.getVertex(0),subFace11.getVertex(2),dihedralAngle01, 16);
  tmp = snubCuboctahedronTree.returnPositionFace(11,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 16
  Face subFace17 = new Face(Face.SQUARE,subFace16.getVertex(2), subFace16.getVertex(1),dihedralAngle02, 17);
  tmp = snubCuboctahedronTree.returnPositionFace(16,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 17
  Face subFace18 = new Face(Face.TRIANGLE, subFace17.getVertex(3), subFace17.getVertex(2), dihedralAngle02, 18);
  tmp = snubCuboctahedronTree.returnPositionFace(17,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.TRIANGLE,subFace18.getVertex(0),subFace18.getVertex(2),dihedralAngle01, 19);
  tmp = snubCuboctahedronTree.returnPositionFace(18,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 00
  Face subFace20 = new Face(Face.TRIANGLE, subFace00.getVertex(3), subFace00.getVertex(2), dihedralAngle02, 20);
  tmp = snubCuboctahedronTree.returnPositionFace(00, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 20
  Face subFace21 = new Face(Face.TRIANGLE, subFace20.getVertex(2),subFace20.getVertex(1),dihedralAngle01, 21);
  tmp = snubCuboctahedronTree.returnPositionFace(20,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 21
  Face subFace22 = new Face(Face.TRIANGLE,subFace21.getVertex(0),subFace21.getVertex(2),dihedralAngle01, 22);
  tmp = snubCuboctahedronTree.returnPositionFace(21,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 22
  Face subFace23 = new Face(Face.TRIANGLE,subFace22.getVertex(2),subFace22.getVertex(1),dihedralAngle01, 23);
  tmp = snubCuboctahedronTree.returnPositionFace(22,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 23
  Face subFace24 = new Face(Face.TRIANGLE, subFace23.getVertex(0),subFace23.getVertex(2),dihedralAngle01, 24);
  tmp = snubCuboctahedronTree.returnPositionFace(23,snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 20
  Face subFace25 = new Face(Face.TRIANGLE, subFace20.getVertex(0), subFace20.getVertex(2), dihedralAngle01, 25);
  tmp = snubCuboctahedronTree.returnPositionFace(20, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace25);

  //Insere a face 26 cuja me  a subface 25
  Face subFace26 = new Face(Face.SQUARE, subFace25.getVertex(2), subFace25.getVertex(1), dihedralAngle02, 26);
  tmp = snubCuboctahedronTree.returnPositionFace(25, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace26);

  //Insere a face 27 cuja me  a subface 26
  Face subFace27 = new Face(Face.TRIANGLE, subFace26.getVertex(3), subFace26.getVertex(2), dihedralAngle02, 27);
  tmp = snubCuboctahedronTree.returnPositionFace(26, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace27);

  //Insere a face 28 cuja me  a subface 27
  Face subFace28 = new Face(Face.TRIANGLE, subFace27.getVertex(0), subFace27.getVertex(2), dihedralAngle01, 28);
  tmp = snubCuboctahedronTree.returnPositionFace(27, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace28);

  //Insere a face 29 cuja me  a subface 00
  Face subFace29 = new Face(Face.TRIANGLE, subFace00.getVertex(0), subFace00.getVertex(3), dihedralAngle02, 29);
  tmp = snubCuboctahedronTree.returnPositionFace(0, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace29);

  //Insere a face 30 cuja me  a subface 29
  Face subFace30 = new Face(Face.TRIANGLE, subFace29.getVertex(2), subFace29.getVertex(1), dihedralAngle01, 30);
  tmp = snubCuboctahedronTree.returnPositionFace(29, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace30);

  //Insere a face 31 cuja me  a subface 30
  Face subFace31 = new Face(Face.TRIANGLE, subFace30.getVertex(0), subFace30.getVertex(2), dihedralAngle01, 31);
  tmp = snubCuboctahedronTree.returnPositionFace(30, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace31);

  //Insere a face 32 cuja me  a subface 31
  Face subFace32 = new Face(Face.TRIANGLE, subFace31.getVertex(2), subFace31.getVertex(1), dihedralAngle01, 32);
  tmp = snubCuboctahedronTree.returnPositionFace(31, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace32);

  //Insere a face 33 cuja me  a subface 32
  Face subFace33 = new Face(Face.TRIANGLE, subFace32.getVertex(0), subFace32.getVertex(2), dihedralAngle01, 33);
  tmp = snubCuboctahedronTree.returnPositionFace(32, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace33);

  //Insere a face 34 cuja me  a subface 29
  Face subFace34 = new Face(Face.TRIANGLE, subFace29.getVertex(0), subFace29.getVertex(2), dihedralAngle01, 34);
  tmp = snubCuboctahedronTree.returnPositionFace(29, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace34);

  //Insere a face 35 cuja me  a subface 34
  Face subFace35 = new Face(Face.SQUARE, subFace34.getVertex(2), subFace34.getVertex(1), dihedralAngle02, 35);
  tmp = snubCuboctahedronTree.returnPositionFace(34, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace35);

  //Insere a face 36 cuja me  a subface 35
  Face subFace36 = new Face(Face.TRIANGLE, subFace35.getVertex(3), subFace35.getVertex(2), dihedralAngle02, 36);
  tmp = snubCuboctahedronTree.returnPositionFace(35, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace36);

  //Insere a face 37 cuja me  a subface 36
  Face subFace37 = new Face(Face.TRIANGLE, subFace36.getVertex(0), subFace36.getVertex(2), dihedralAngle01, 37);
  tmp = snubCuboctahedronTree.returnPositionFace(36, snubCuboctahedronTree);
  snubCuboctahedronTree.insertLastChild(tmp, subFace37);

  return snubCuboctahedronTree;

  }


  public static Face generateSnubIcosidodecahedron(){
  double dihedralAngle01 = Math.PI-9851*Math.PI/10800;//Dihedral angle between polygons with 3 and 3 sides
  double dihedralAngle02 = Math.PI-1147*Math.PI/1350; //Dihedral angle between polygons with 3 and 5 sides


  Face snubIcosidodecahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face subFace00 = new Face(Face.PENTAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle01, 0);
  snubIcosidodecahedronTree.replaceElement(snubIcosidodecahedronTree.root(),subFace00);

  //Insere a face 01 cuja me  a subface00
  Face subFace01 = new Face(Face.TRIANGLE, subFace00.getVertex(1), subFace00.getVertex(0),dihedralAngle02, 1);
  tmp = snubIcosidodecahedronTree.returnPositionFace(0,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.TRIANGLE, subFace01.getVertex(2), subFace01.getVertex(1),dihedralAngle01, 2);
  tmp = snubIcosidodecahedronTree.returnPositionFace(1,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface 02
  Face subFace03 = new Face(Face.TRIANGLE, subFace02.getVertex(0), subFace02.getVertex(2),dihedralAngle01, 3);
  tmp = snubIcosidodecahedronTree.returnPositionFace(2,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.TRIANGLE, subFace03.getVertex(2), subFace03.getVertex(1),dihedralAngle01, 4);
  tmp = snubIcosidodecahedronTree.returnPositionFace(3,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.TRIANGLE, subFace04.getVertex(0), subFace04.getVertex(2),dihedralAngle01, 5);
  tmp = snubIcosidodecahedronTree.returnPositionFace(4,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 01
  Face subFace06 = new Face(Face.TRIANGLE,subFace01.getVertex(0), subFace01.getVertex(2),dihedralAngle01, 6);
  tmp = snubIcosidodecahedronTree.returnPositionFace(1,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.PENTAGON,subFace06.getVertex(2),subFace06.getVertex(1),dihedralAngle02, 7);
  tmp = snubIcosidodecahedronTree.returnPositionFace(6, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 07
  Face subFace08 = new Face(Face.TRIANGLE,subFace07.getVertex(3),subFace07.getVertex(2),dihedralAngle02, 8);
  tmp = snubIcosidodecahedronTree.returnPositionFace(7, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace08);

  //Insere a face 09 cuja me  a subface 08
  Face subFace09 = new Face(Face.TRIANGLE, subFace08.getVertex(0), subFace08.getVertex(2),dihedralAngle01, 9);
  tmp = snubIcosidodecahedronTree.returnPositionFace(8,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 09
  Face subFace10 = new Face(Face.PENTAGON,subFace09.getVertex(2), subFace09.getVertex(1),dihedralAngle02, 10);
  tmp = snubIcosidodecahedronTree.returnPositionFace(9,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 10
  Face subFace11 = new Face(Face.TRIANGLE,subFace10.getVertex(4), subFace10.getVertex(3),dihedralAngle02, 11);
  tmp = snubIcosidodecahedronTree.returnPositionFace(10,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace11);

  //Insere a face 12 cuja me  a subface 11
  Face subFace12 = new Face(Face.TRIANGLE,subFace11.getVertex(2),subFace11.getVertex(1),dihedralAngle01, 12);
  tmp = snubIcosidodecahedronTree.returnPositionFace(11,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace12);

  //Insere a face 13 cuja me  a subface 11
  Face subFace13 = new Face(Face.TRIANGLE,subFace11.getVertex(0),subFace11.getVertex(2),dihedralAngle01, 13);
  tmp = snubIcosidodecahedronTree.returnPositionFace(11,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace13);

  //Insere a face 14 cuja me  a subface 13
  Face subFace14 = new Face(Face.PENTAGON,subFace13.getVertex(2),subFace13.getVertex(1),dihedralAngle02, 14);
  tmp = snubIcosidodecahedronTree.returnPositionFace(13,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace14);

  //Insere a face 15 cuja me  a subface 07
  Face subFace15 = new Face(Face.TRIANGLE,subFace07.getVertex(4),subFace07.getVertex(3),dihedralAngle02, 15);
  tmp = snubIcosidodecahedronTree.returnPositionFace(7,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace15);

  //Insere a face 16 cuja me  a subface 15
  Face subFace16 = new Face(Face.TRIANGLE,subFace15.getVertex(2), subFace15.getVertex(1),dihedralAngle01, 16);
  tmp = snubIcosidodecahedronTree.returnPositionFace(15,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace16);

  //Insere a face 17 cuja me  a subface 16
  Face subFace17 = new Face(Face.TRIANGLE,subFace16.getVertex(0), subFace16.getVertex(2),dihedralAngle01, 17);
  tmp = snubIcosidodecahedronTree.returnPositionFace(16,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace17);

  //Insere a face 18 cuja me  a subface 17
  Face subFace18 = new Face(Face.TRIANGLE, subFace17.getVertex(2), subFace17.getVertex(1), dihedralAngle01, 18);
  tmp = snubIcosidodecahedronTree.returnPositionFace(17,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace18);

  //Insere a face 19 cuja me  a subface 18
  Face subFace19 = new Face(Face.TRIANGLE,subFace18.getVertex(0),subFace18.getVertex(2),dihedralAngle01, 19);
  tmp = snubIcosidodecahedronTree.returnPositionFace(18,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace19);

  //Insere a face 20 cuja me  a subface 15
  Face subFace20 = new Face(Face.TRIANGLE, subFace15.getVertex(0), subFace15.getVertex(2), dihedralAngle01, 20);
  tmp = snubIcosidodecahedronTree.returnPositionFace(15, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace20);

  //Insere a face 21 cuja me  a subface 20
  Face subFace21 = new Face(Face.PENTAGON, subFace20.getVertex(2),subFace20.getVertex(1),dihedralAngle02, 21);
  tmp = snubIcosidodecahedronTree.returnPositionFace(20,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace21);

  //Insere a face 22 cuja me  a subface 21
  Face subFace22 = new Face(Face.TRIANGLE,subFace21.getVertex(3),subFace21.getVertex(2),dihedralAngle02, 22);
  tmp = snubIcosidodecahedronTree.returnPositionFace(21,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace22);

  //Insere a face 23 cuja me  a subface 22
  Face subFace23 = new Face(Face.TRIANGLE,subFace22.getVertex(0),subFace22.getVertex(2),dihedralAngle01, 23);
  tmp = snubIcosidodecahedronTree.returnPositionFace(22,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace23);

  //Insere a face 24 cuja me  a subface 21
  Face subFace24 = new Face(Face.TRIANGLE, subFace21.getVertex(4),subFace21.getVertex(3),dihedralAngle02, 24);
  tmp = snubIcosidodecahedronTree.returnPositionFace(21,snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp,subFace24);

  //Insere a face 25 cuja me  a subface 24
  Face subFace25 = new Face(Face.TRIANGLE, subFace24.getVertex(2), subFace24.getVertex(1), dihedralAngle01, 25);
  tmp = snubIcosidodecahedronTree.returnPositionFace(24, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace25);

  //Insere a face 26 cuja me  a subface 00
  Face subFace26 = new Face(Face.TRIANGLE, subFace00.getVertex(2), subFace00.getVertex(1), dihedralAngle02, 26);
  tmp = snubIcosidodecahedronTree.returnPositionFace(0, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace26);

  //Insere a face 27 cuja me  a subface 26
  Face subFace27 = new Face(Face.TRIANGLE, subFace26.getVertex(2), subFace26.getVertex(1), dihedralAngle01, 27);
  tmp = snubIcosidodecahedronTree.returnPositionFace(26, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace27);

  //Insere a face 28 cuja me  a subface 27
  Face subFace28 = new Face(Face.TRIANGLE, subFace27.getVertex(0), subFace27.getVertex(2), dihedralAngle01, 28);
  tmp = snubIcosidodecahedronTree.returnPositionFace(27, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace28);

  //Insere a face 29 cuja me  a subface 28
  Face subFace29 = new Face(Face.TRIANGLE, subFace28.getVertex(2), subFace28.getVertex(1), dihedralAngle01, 29);
  tmp = snubIcosidodecahedronTree.returnPositionFace(28, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace29);

  //Insere a face 30 cuja me  a subface 29
  Face subFace30 = new Face(Face.TRIANGLE, subFace29.getVertex(0), subFace29.getVertex(2), dihedralAngle01, 30);
  tmp = snubIcosidodecahedronTree.returnPositionFace(29, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace30);

  //Insere a face 31 cuja me  a subface 26
  Face subFace31 = new Face(Face.TRIANGLE, subFace26.getVertex(0), subFace26.getVertex(2), dihedralAngle01, 31);
  tmp = snubIcosidodecahedronTree.returnPositionFace(26, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace31);

  //Insere a face 32 cuja me  a subface 31
  Face subFace32 = new Face(Face.PENTAGON, subFace31.getVertex(2), subFace31.getVertex(1), dihedralAngle02, 32);
  tmp = snubIcosidodecahedronTree.returnPositionFace(31, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace32);

  //Insere a face 33 cuja me  a subface 32
  Face subFace33 = new Face(Face.TRIANGLE, subFace32.getVertex(3), subFace32.getVertex(2), dihedralAngle02, 33);
  tmp = snubIcosidodecahedronTree.returnPositionFace(32, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace33);

  //Insere a face 34 cuja me  a subface 33
  Face subFace34 = new Face(Face.TRIANGLE, subFace33.getVertex(0), subFace33.getVertex(2), dihedralAngle01, 34);
  tmp = snubIcosidodecahedronTree.returnPositionFace(33, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace34);

  //Insere a face 35 cuja me  a subface 32
  Face subFace35 = new Face(Face.TRIANGLE, subFace32.getVertex(4), subFace32.getVertex(3), dihedralAngle02, 35);
  tmp = snubIcosidodecahedronTree.returnPositionFace(32, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace35);

  //Insere a face 36 cuja me  a subface 35
  Face subFace36 = new Face(Face.TRIANGLE, subFace35.getVertex(2), subFace35.getVertex(1), dihedralAngle01, 36);
  tmp = snubIcosidodecahedronTree.returnPositionFace(35, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace36);

  //Insere a face 37 cuja me  a subface 36
  Face subFace37 = new Face(Face.TRIANGLE, subFace36.getVertex(0), subFace36.getVertex(2), dihedralAngle01, 37);
  tmp = snubIcosidodecahedronTree.returnPositionFace(36, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace37);

  //Insere a face 38 cuja me  a subface 35
  Face subFace38 = new Face(Face.TRIANGLE, subFace35.getVertex(0), subFace35.getVertex(2), dihedralAngle01, 38);
  tmp = snubIcosidodecahedronTree.returnPositionFace(35, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace38);

  //Insere a face 39 cuja me  a subface 38
  Face subFace39 = new Face(Face.PENTAGON, subFace38.getVertex(2), subFace38.getVertex(1), dihedralAngle02, 39);
  tmp = snubIcosidodecahedronTree.returnPositionFace(38, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace39);

  //Insere a face 40 cuja me  a subface 39
  Face subFace40 = new Face(Face.TRIANGLE, subFace39.getVertex(3), subFace39.getVertex(2), dihedralAngle02, 40);
  tmp = snubIcosidodecahedronTree.returnPositionFace(39, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace40);

  //Insere a face 41 cuja me  a subface 40
  Face subFace41 = new Face(Face.TRIANGLE, subFace40.getVertex(0), subFace40.getVertex(2), dihedralAngle01, 41);
  tmp = snubIcosidodecahedronTree.returnPositionFace(40, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace41);

  //Insere a face 42 cuja me  a subface 39
  Face subFace42 = new Face(Face.TRIANGLE, subFace39.getVertex(4), subFace39.getVertex(3), dihedralAngle02, 42);
  tmp = snubIcosidodecahedronTree.returnPositionFace(39, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace42);

  //Insere a face 43 cuja me  a subface 42
  Face subFace43 = new Face(Face.TRIANGLE, subFace42.getVertex(2), subFace42.getVertex(1), dihedralAngle01, 43);
  tmp = snubIcosidodecahedronTree.returnPositionFace(42, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace43);

  //Insere a face 44 cuja me  a subface 00
  Face subFace44 = new Face(Face.TRIANGLE, subFace00.getVertex(3), subFace00.getVertex(2), dihedralAngle02, 44);
  tmp = snubIcosidodecahedronTree.returnPositionFace(0, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace44);

  //Insere a face 45 cuja me  a subface 44
  Face subFace45 = new Face(Face.TRIANGLE, subFace44.getVertex(2), subFace44.getVertex(1), dihedralAngle01, 45);
  tmp = snubIcosidodecahedronTree.returnPositionFace(44, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace45);

  //Insere a face 46 cuja me  a subface 45
  Face subFace46 = new Face(Face.TRIANGLE, subFace45.getVertex(0), subFace45.getVertex(2), dihedralAngle01, 46);
  tmp = snubIcosidodecahedronTree.returnPositionFace(45, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace46);

  //Insere a face 47 cuja me  a subface 46
  Face subFace47 = new Face(Face.TRIANGLE, subFace46.getVertex(2), subFace46.getVertex(1), dihedralAngle01, 47);
  tmp = snubIcosidodecahedronTree.returnPositionFace(46, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace47);

  //Insere a face 48 cuja me  a subface 47
  Face subFace48 = new Face(Face.TRIANGLE, subFace47.getVertex(0), subFace47.getVertex(2), dihedralAngle01, 48);
  tmp = snubIcosidodecahedronTree.returnPositionFace(47, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace48);

  //Insere a face 49 cuja me  a subface 44
  Face subFace49 = new Face(Face.TRIANGLE, subFace44.getVertex(0), subFace44.getVertex(2), dihedralAngle01, 49);
  tmp = snubIcosidodecahedronTree.returnPositionFace(44, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace49);

  //Insere a face 50 cuja me  a subface 49
  Face subFace50 = new Face(Face.PENTAGON, subFace49.getVertex(2), subFace49.getVertex(1), dihedralAngle02, 50);
  tmp = snubIcosidodecahedronTree.returnPositionFace(49, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace50);

  //Insere a face 51 cuja me  a subface 50
  Face subFace51 = new Face(Face.TRIANGLE, subFace50.getVertex(3), subFace50.getVertex(2), dihedralAngle02, 51);
  tmp = snubIcosidodecahedronTree.returnPositionFace(50, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace51);

  //Insere a face 52 cuja me  a subface 51
  Face subFace52 = new Face(Face.TRIANGLE, subFace51.getVertex(0), subFace51.getVertex(2), dihedralAngle01, 52);
  tmp = snubIcosidodecahedronTree.returnPositionFace(51, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace52);

  //Insere a face 53 cuja me  a subface 50
  Face subFace53 = new Face(Face.TRIANGLE, subFace50.getVertex(4), subFace50.getVertex(3), dihedralAngle02, 53);
  tmp = snubIcosidodecahedronTree.returnPositionFace(50, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace53);

  //Insere a face 54 cuja me  a subface 53
  Face subFace54 = new Face(Face.TRIANGLE, subFace53.getVertex(0), subFace53.getVertex(2), dihedralAngle01, 54);
  tmp = snubIcosidodecahedronTree.returnPositionFace(53, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace54);

  //Insere a face 55 cuja me  a subface 54
  Face subFace55 = new Face(Face.PENTAGON, subFace54.getVertex(2), subFace54.getVertex(1), dihedralAngle02, 55);
  tmp = snubIcosidodecahedronTree.returnPositionFace(54, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace55);

  //Insere a face 56 cuja me  a subface 55
  Face subFace56 = new Face(Face.TRIANGLE, subFace55.getVertex(3), subFace55.getVertex(2), dihedralAngle02, 56);
  tmp = snubIcosidodecahedronTree.returnPositionFace(55, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace56);

  //Insere a face 57 cuja me  a subface 56
  Face subFace57 = new Face(Face.TRIANGLE, subFace56.getVertex(0), subFace56.getVertex(2), dihedralAngle01, 57);
  tmp = snubIcosidodecahedronTree.returnPositionFace(56, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace57);

  //Insere a face 58 cuja me  a subface 55
  Face subFace58 = new Face(Face.TRIANGLE, subFace55.getVertex(4), subFace55.getVertex(3), dihedralAngle02, 58);
  tmp = snubIcosidodecahedronTree.returnPositionFace(55, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace58);

  //Insere a face 59 cuja me  a subface 58
  Face subFace59 = new Face(Face.TRIANGLE, subFace58.getVertex(2), subFace58.getVertex(1), dihedralAngle01, 59);
  tmp = snubIcosidodecahedronTree.returnPositionFace(58, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace59);

  //Insere a face 60 cuja me  a subface 53
  Face subFace60 = new Face(Face.TRIANGLE, subFace53.getVertex(2), subFace53.getVertex(1), dihedralAngle01, 60);
  tmp = snubIcosidodecahedronTree.returnPositionFace(53, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace60);

  //Insere a face 61 cuja me  a subface 60
  Face subFace61 = new Face(Face.TRIANGLE, subFace60.getVertex(0), subFace60.getVertex(2), dihedralAngle01, 61);
  tmp = snubIcosidodecahedronTree.returnPositionFace(60, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace61);

  //Insere a face 62 cuja me  a subface 00
  Face subFace62 = new Face(Face.TRIANGLE, subFace00.getVertex(4), subFace00.getVertex(3), dihedralAngle02, 62);
  tmp = snubIcosidodecahedronTree.returnPositionFace(0, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace62);

  //Insere a face 63 cuja me  a subface 62
  Face subFace63 = new Face(Face.TRIANGLE, subFace62.getVertex(2), subFace62.getVertex(1), dihedralAngle01, 63);
  tmp = snubIcosidodecahedronTree.returnPositionFace(62, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace63);

  //Insere a face 64 cuja me  a subface 63
  Face subFace64 = new Face(Face.TRIANGLE, subFace63.getVertex(0), subFace63.getVertex(2), dihedralAngle01, 64);
  tmp = snubIcosidodecahedronTree.returnPositionFace(63, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace64);

  //Insere a face 65 cuja me  a subface 64
  Face subFace65 = new Face(Face.TRIANGLE, subFace64.getVertex(2), subFace64.getVertex(1), dihedralAngle01, 65);
  tmp = snubIcosidodecahedronTree.returnPositionFace(64, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace65);

  //Insere a face 66 cuja me  a subface 65
  Face subFace66 = new Face(Face.TRIANGLE, subFace65.getVertex(0), subFace65.getVertex(2), dihedralAngle01, 66);
  tmp = snubIcosidodecahedronTree.returnPositionFace(65, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace66);

  //Insere a face 67 cuja me  a subface 62
  Face subFace67 = new Face(Face.TRIANGLE, subFace62.getVertex(0), subFace62.getVertex(2), dihedralAngle01, 67);
  tmp = snubIcosidodecahedronTree.returnPositionFace(62, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace67);

  //Insere a face 68 cuja me  a subface 67
  Face subFace68 = new Face(Face.PENTAGON, subFace67.getVertex(2), subFace67.getVertex(1), dihedralAngle02, 68);
  tmp = snubIcosidodecahedronTree.returnPositionFace(67, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace68);

  //Insere a face 69 cuja me  a subface 68
  Face subFace69 = new Face(Face.TRIANGLE, subFace68.getVertex(3), subFace68.getVertex(2), dihedralAngle02, 69);
  tmp = snubIcosidodecahedronTree.returnPositionFace(68, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace69);

  //Insere a face 70 cuja me  a subface 69
  Face subFace70 = new Face(Face.TRIANGLE, subFace69.getVertex(0), subFace69.getVertex(2), dihedralAngle01, 70);
  tmp = snubIcosidodecahedronTree.returnPositionFace(69, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace70);

  //Insere a face 71 cuja me  a subface 68
  Face subFace71 = new Face(Face.TRIANGLE, subFace68.getVertex(4), subFace68.getVertex(3), dihedralAngle02, 71);
  tmp = snubIcosidodecahedronTree.returnPositionFace(68, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace71);

  //Insere a face 72 cuja me  a subface 71
  Face subFace72 = new Face(Face.TRIANGLE, subFace71.getVertex(2), subFace71.getVertex(1), dihedralAngle01, 72);
  tmp = snubIcosidodecahedronTree.returnPositionFace(71, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace72);

  //Insere a face 73 cuja me  a subface 72
  Face subFace73 = new Face(Face.TRIANGLE, subFace72.getVertex(0), subFace72.getVertex(2), dihedralAngle01, 73);
  tmp = snubIcosidodecahedronTree.returnPositionFace(72, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace73);

  //Insere a face 74 cuja me  a subface 71
  Face subFace74 = new Face(Face.TRIANGLE, subFace71.getVertex(0), subFace71.getVertex(2), dihedralAngle01, 74);
  tmp = snubIcosidodecahedronTree.returnPositionFace(71, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace74);

  //Insere a face 75 cuja me  a subface 74
  Face subFace75 = new Face(Face.PENTAGON, subFace74.getVertex(2), subFace74.getVertex(1), dihedralAngle02, 75);
  tmp = snubIcosidodecahedronTree.returnPositionFace(74, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace75);

  //Insere a face 76 cuja me  a subface 75
  Face subFace76 = new Face(Face.TRIANGLE, subFace75.getVertex(3), subFace75.getVertex(2), dihedralAngle02, 76);
  tmp = snubIcosidodecahedronTree.returnPositionFace(75, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace76);

  //Insere a face 77 cuja me  a subface 76
  Face subFace77 = new Face(Face.TRIANGLE, subFace76.getVertex(0), subFace76.getVertex(2), dihedralAngle01, 77);
  tmp = snubIcosidodecahedronTree.returnPositionFace(76, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace77);

  //Insere a face 78 cuja me  a subface 75
  Face subFace78 = new Face(Face.TRIANGLE, subFace75.getVertex(4), subFace75.getVertex(3), dihedralAngle02, 78);
  tmp = snubIcosidodecahedronTree.returnPositionFace(75, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace78);

  //Insere a face 79 cuja me  a subface 00
  Face subFace79 = new Face(Face.TRIANGLE, subFace00.getVertex(0), subFace00.getVertex(4), dihedralAngle02, 79);
  tmp = snubIcosidodecahedronTree.returnPositionFace(0, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace79);

  //Insere a face 80 cuja me  a subface 79
  Face subFace80 = new Face(Face.TRIANGLE, subFace79.getVertex(2), subFace79.getVertex(1), dihedralAngle01, 80);
  tmp = snubIcosidodecahedronTree.returnPositionFace(79, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace80);

  //Insere a face 81 cuja me  a subface 80
  Face subFace81 = new Face(Face.TRIANGLE, subFace80.getVertex(0), subFace80.getVertex(2), dihedralAngle01, 81);
  tmp = snubIcosidodecahedronTree.returnPositionFace(80, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace81);

  //Insere a face 82 cuja me  a subface 81
  Face subFace82 = new Face(Face.TRIANGLE, subFace81.getVertex(2), subFace81.getVertex(1), dihedralAngle01, 82);
  tmp = snubIcosidodecahedronTree.returnPositionFace(81, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace82);

  //Insere a face 83 cuja me  a subface 82
  Face subFace83 = new Face(Face.TRIANGLE, subFace82.getVertex(0), subFace82.getVertex(2), dihedralAngle01, 83);
  tmp = snubIcosidodecahedronTree.returnPositionFace(82, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace83);

  //Insere a face 84 cuja me  a subface 79
  Face subFace84 = new Face(Face.TRIANGLE, subFace79.getVertex(0), subFace79.getVertex(2), dihedralAngle01, 84);
  tmp = snubIcosidodecahedronTree.returnPositionFace(79, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace84);

  //Insere a face 85 cuja me  a subface 84
  Face subFace85 = new Face(Face.PENTAGON, subFace84.getVertex(2), subFace84.getVertex(1), dihedralAngle02, 85);
  tmp = snubIcosidodecahedronTree.returnPositionFace(84, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace85);

  //Insere a face 86 cuja me  a subface 85
  Face subFace86 = new Face(Face.TRIANGLE, subFace85.getVertex(3), subFace85.getVertex(2), dihedralAngle02, 86);
  tmp = snubIcosidodecahedronTree.returnPositionFace(85, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace86);

  //Insere a face 87 cuja me  a subface 86
  Face subFace87 = new Face(Face.TRIANGLE, subFace86.getVertex(0), subFace86.getVertex(2), dihedralAngle01, 87);
  tmp = snubIcosidodecahedronTree.returnPositionFace(86, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace87);

  //Insere a face 88 cuja me  a subface 85
  Face subFace88 = new Face(Face.TRIANGLE, subFace85.getVertex(4), subFace85.getVertex(3), dihedralAngle02, 88);
  tmp = snubIcosidodecahedronTree.returnPositionFace(85, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace88);

  //Insere a face 89 cuja me  a subface 88
  Face subFace89 = new Face(Face.TRIANGLE, subFace88.getVertex(2), subFace88.getVertex(1), dihedralAngle01, 89);
  tmp = snubIcosidodecahedronTree.returnPositionFace(88, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace89);

  //Insere a face 90 cuja me  a subface 89
  Face subFace90 = new Face(Face.TRIANGLE, subFace89.getVertex(0), subFace89.getVertex(2), dihedralAngle01, 90);
  tmp = snubIcosidodecahedronTree.returnPositionFace(89, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace90);

  //Insere a face 91 cuja me  a subface 88
  Face subFace91 = new Face(Face.TRIANGLE, subFace88.getVertex(0), subFace88.getVertex(2), dihedralAngle01, 91);
  tmp = snubIcosidodecahedronTree.returnPositionFace(88, snubIcosidodecahedronTree);
  snubIcosidodecahedronTree.insertLastChild(tmp, subFace91);

  return snubIcosidodecahedronTree;

  }




}