package ic;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

//Imports the JDSL Classes (Java Data Structure Library)
import jdsl.core.ref.*;
import jdsl.core.api.*;

//Imports the JV Classes (Java Viewer - 3D Libray)
import jv.vecmath.*;
import jv.viewer.*;
import jv.geom.*;

public class MatHSoliD extends JApplet {
  private Face spaceSolid;
  private PgElementSet solid = new PgElementSet(3);

  //Icons exhibited in the buttons
  private ImageIcon iconTriangle, iconSquare, iconPentagon, iconHexagon, iconHeptagon,
      iconOctogon, iconEneagon, iconDecagon, imgLogo;
  private ImageIcon iconMode01, iconMode02, iconMode03, iconMode04, iconMode05, iconMode06, iconMode07, iconMode08, iconMode09;

  private MatHSoliDLanguages languages;
  //Array used to build the comboboxes cmbSolids and cmbCategorySolids
  /*String [] categoryOfSolids = {"Platonic Solids", "Archimedean Solids"};
  String [] platonicsSolids = {"Regular Tetrahedron","Cube","Regular Octahedron",
      "Regular Dodecahedron","Regular Icosahedron"};
  String [] archimedeanSolids = {"Truncated Tetrahedron",
      "Cuboctahedron","Truncated Cube","Truncated Octahedron","Rhombicuboctahedron",
      "RhombiTruncated Cuboctahedron", "RhombiTruncated Icosidodecahedron",
      "Icosidodecahedron","Rhombicosidodecahedron", "Truncated Dodecahedron",
      "Truncated Icosahedron", "Snub Cuboctahedron", "Snub Icosidodecahedron"};*/

  //It builds the component that exhibits the geometric solids allowing interaction with the user.
  PvDisplay display = new PvDisplay();
  PvViewer manageViewer;

  //It creates a new instance of component JSlider. This component allows the
  //user it to determine the percentile of opening among the faces of the solid.
  JSlider sliderRotation = new JSlider(0,100,0);

  //ComboBox with the categories of solids, for example: platonic solids, archimedean solids, etc.
  JComboBox cmbCategorySolids;

  //ComboBox with the solids
  JComboBox CmbSolids;// = new JComboBox(platonicsSolids);

  //Panel of colors to select the colors of the faces of the solid exhibited in the display.
  JColorChooser Cc1 = new JColorChooser();

  JButton btnEdgeColor = new JButton();

  //Group of ToggleButtons that determine the style of the solid exhibited in the display.
  JPanel pnlToggleButtons = new JPanel();
  JToggleButton tbtnMode01 = new JToggleButton();
  JToggleButton tbtnMode02 = new JToggleButton();
  JToggleButton tbtnMode03 = new JToggleButton();
  JToggleButton tbtnMode04 = new JToggleButton();
  JToggleButton tbtnMode05 = new JToggleButton();
  JToggleButton tbtnMode06 = new JToggleButton();
  JToggleButton tbtnMode07 = new JToggleButton();
  JToggleButton tbtnMode08 = new JToggleButton();
  GridLayout gridLayoutPnlToggleButtons = new GridLayout(3,3);

  ButtonGroup btnGroup = new ButtonGroup();
  JPanel pnlSetup = new JPanel();
  JCheckBox chkShowFaces = new JCheckBox();
  JCheckBox chkShowEdges = new JCheckBox();
  GridLayout gridLayoutPnlSetup = new GridLayout(10,1);
  JCheckBox chkShowVertices = new JCheckBox();
  JCheckBox chkEnableDepth = new JCheckBox();
  JCheckBox chkEnableFit = new JCheckBox();
  JCheckBox chkEnableTransparency = new JCheckBox();
  JButton btnResetCamera = new JButton();
  JToggleButton tbtnSetup = new JToggleButton();
  JToggleButton tbtnMode09 = new JToggleButton();

  //Group of buttons that determine the colors of the solid exhibited in the display.
  JPanel pnlBtnColors = new JPanel();
  JButton BtnColorTriangles = new JButton();
  JButton BtnColorOctogons = new JButton();
  JButton BtnColorHexagons = new JButton();
  JButton BtnColorPentagon = new JButton();
  JButton BtnColorEneagons = new JButton();
  JButton BtnColorHeptagons = new JButton();
  JButton BtnColorSquares = new JButton();
  JButton BtnColorDecagons = new JButton();

  JToggleButton tbtnViewBtnColors = new JToggleButton();
  ButtonGroup btnGroupBtnViewOptions = new ButtonGroup();

  private boolean isStandalone = false;
  String appletLanguage;
  int percRotation = 0;
  String initialSolid;
  String backgroundColor;
  boolean controlPanel=true;
  int indexVisual=0;
  double edgeThickness = 1.0;
  boolean enableFit = true;
  Color Colors[]=new Color[11];

  int inc = 1; //Stores the value to increment the slider
  long tempInc = 0;
  int wait = 1000;
  java.util.Calendar c = java.util.Calendar.getInstance();

  private javax.swing.Timer timer = new javax.swing.Timer(1,new ActionListener(){
      public void actionPerformed(ActionEvent evt) {

        if(sliderRotation.getValue()>=sliderRotation.getMaximum()){
          sliderRotation.setValue(sliderRotation.getMaximum());
          inc*=-1;
          c = java.util.Calendar.getInstance();
          tempInc=c.getTimeInMillis();

          timer.stop();
          while(tempInc+wait>c.getTimeInMillis()){
            c = java.util.Calendar.getInstance();
            try{
              timer.wait(1000);
            }
            catch(Exception exp){
            }
          }
          timer.start();

        }
        if(sliderRotation.getValue()<=sliderRotation.getMinimum()){
          sliderRotation.setValue(sliderRotation.getMinimum());
          inc*=-1;

          c = java.util.Calendar.getInstance();
          tempInc=c.getTimeInMillis();

          timer.stop();
          while(tempInc+wait>c.getTimeInMillis()){
            c = java.util.Calendar.getInstance();
            try{
              timer.wait();
            }
            catch(Exception exp){
            }
          }
          timer.start();

        }
        sliderRotation.setValue(sliderRotation.getValue()+inc);
      }
  });


  JSlider sliderTransparency = new JSlider(0,100,50);
  JButton btnSave = new JButton();
  JButton btnBgColorDisplay = new JButton();
  JButton btnCopyRight = new JButton();
  JCheckBox chkAutoAnimation = new JCheckBox();
  JButton btnImage = new JButton();
  static JFrame frame;
  JLabel lblRotationPerc = new JLabel();



  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :(getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public MatHSoliD() {
  }
  //Initialize the applet
  public void init() {
    try {
      appletLanguage = this.getParameter("appletLanguage", "english");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      percRotation = Integer.parseInt(this.getParameter("percRotation", "0"));
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      edgeThickness = Double.parseDouble(this.getParameter("edgeThickness", "1.0"));
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    try {
      enableFit = (Boolean.valueOf(this.getParameter("enableFit", "true"))).booleanValue();;
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    try {
      initialSolid = this.getParameter("initialSolid", "Regular Tetrahedron");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      backgroundColor = this.getParameter("backgroundColor", "#000000");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      controlPanel = (Boolean.valueOf(this.getParameter("controlPanel", "true"))).booleanValue();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      indexVisual = Integer.parseInt(this.getParameter("indexVisual", "1"));
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private ImageIcon createIcon(String path){
    ImageIcon icon = null;
    java.net.URL imgURL = MatHSoliD.class.getResource(path);
    try{
      if (imgURL!=null)
        icon = new ImageIcon(imgURL);
    }
    catch(Exception exp){
      exp.printStackTrace();
    }

    return icon;
  }
  //Component initialization
  private void jbInit() throws Exception {
    //MatHSoliDLanguages languages = new MatHSoliDLanguages("germany");
    //if(!this.language.equals("english"))
      languages = new MatHSoliDLanguages(this.appletLanguage);

    this.setSize(new Dimension(705, 531));
    //private void initializeComponents() throws Exception {
    //Initialize the ImagenIcons
    this.imgLogo = createIcon("/images/fundo.gif");
    this.imgLogo.setDescription("http://www.mat.puc-rio.br/~hjbortol/mathsolid/");

    this.iconTriangle = createIcon("/images/triangle.gif");
    this.iconSquare = createIcon("/images/square.gif");
    this.iconPentagon = createIcon("/images/pentagon.gif");
    this.iconHexagon = createIcon("/images/hexagon.gif");
    this.iconHeptagon = createIcon("/images/heptagon.gif");
    this.iconOctogon = createIcon("/images/octogon.gif");
    this.iconEneagon = createIcon("/images/eneagon.gif");
    this.iconDecagon = createIcon("/images/decagon.gif");
    this.iconMode01 = createIcon("/images/mode01.gif");
    this.iconMode02 = createIcon("/images/mode02.gif");
    this.iconMode03 = createIcon("/images/mode03.gif");
    this.iconMode04 = createIcon("/images/mode04.gif");
    this.iconMode05 = createIcon("/images/mode05.gif");
    this.iconMode06 = createIcon("/images/mode06.gif");
    this.iconMode07 = createIcon("/images/mode07.gif");
    this.iconMode08 = createIcon("/images/mode08.gif");
    this.iconMode09 = createIcon("/images/mode09.gif");

    cmbCategorySolids = new JComboBox(languages.getCategoryOfSolids());
    if (languages.isPlatonic(this.initialSolid) == true)
    {
        CmbSolids = new JComboBox(languages.getPlatonicSolids());
        cmbCategorySolids.setSelectedIndex(0);
    }
    else
    {
        CmbSolids = new JComboBox(languages.getArchimedeanSolids());
        cmbCategorySolids.setSelectedIndex(1);
    }


    this.getContentPane().setLayout(null);

    display.setBounds(new Rectangle(18, 17, 466, 482));
    display.setBackgroundColor(Utils.getColor(this.backgroundColor));
    display.getCamera().setViewDir(new PdVector(0.0, 0.0, 1.0));
    display.addGeometry(solid);


    if(!this.isStandalone) this.manageViewer = new PvViewer(this,null);
    manageViewer.addDisplay("Default",display);

    solid.setGlobalEdgeColor(Color.WHITE);
    solid.setGlobalVertexColor(Color.WHITE);
    solid.setGlobalVertexSize(2.0);
    solid.showElementColors(true);
    solid.setTransparency(0.0);

    sliderRotation.setExtent(0);
    sliderRotation.setInverted(false);
    sliderRotation.setMinimum(0);
    sliderRotation.setMinorTickSpacing(0);
    sliderRotation.setValue(50);
    sliderRotation.setPaintLabels(true);
    sliderRotation.setPaintTicks(false);
    sliderRotation.setPaintTrack(true);
    sliderRotation.setMinimumSize(new Dimension(36, 32));
    sliderRotation.setOpaque(false);
    sliderRotation.setBounds(new Rectangle(489, 197, 207, 23));
    sliderRotation.addChangeListener(new MatHSoliD_sliderRotation_changeAdapter(this));
    sliderRotation.addMouseListener(new Anim_MouseListener());

    CmbSolids.setPopupVisible(false);
    CmbSolids.setSelectedIndex(0);
    CmbSolids.setBounds(new Rectangle(489, 171, 207, 24));
    CmbSolids.addActionListener(new MatHSoliD_CmbSolids_actionAdapter(this));
    CmbSolids.addItemListener(new MatHSoliD_CmbSolids_itemAdapter(this));

    Cc1.setEnabled(true);
    Cc1.setBounds(new Rectangle(818, 206, 67, 82));
    Cc1.setVisible(false);

    btnEdgeColor.setBounds(new Rectangle(708, 438, 165, 40));
    btnEdgeColor.setText(languages.getColorOfTheEdgesLabel());
    btnEdgeColor.addActionListener(new MatHSoliD_btnEdgeColor_actionAdapter(this));

    pnlToggleButtons.setBackground(new Color(204, 204, 204));
    pnlToggleButtons.setBorder(BorderFactory.createEtchedBorder());
    pnlToggleButtons.setBounds(new Rectangle(489, 16, 207, 124));
    pnlToggleButtons.setLayout(gridLayoutPnlToggleButtons);
    pnlToggleButtons.setVisible(this.controlPanel);

    //Register the listeners
    tbtnMode01.addActionListener(new MatHSoliD_tbtnMode01_actionAdapter(this));
    tbtnMode02.addActionListener(new MatHSoliD_tbtnMode02_actionAdapter(this));
    tbtnMode03.addActionListener(new MatHSoliD_tbtnMode03_actionAdapter(this));
    tbtnMode04.addActionListener(new MatHSoliD_tbtnMode04_actionAdapter(this));
    tbtnMode05.addActionListener(new MatHSoliD_tbtnMode05_actionAdapter(this));
    tbtnMode06.addActionListener(new MatHSoliD_tbtnMode06_actionAdapter(this));
    tbtnMode07.addActionListener(new MatHSoliD_tbtnMode07_actionAdapter(this));
    tbtnMode08.addActionListener(new MatHSoliD_tbtnMode08_actionAdapter(this));

    tbtnMode01.setIcon(this.iconMode01);
    tbtnMode02.setIcon(this.iconMode02);
    tbtnMode03.setIcon(this.iconMode03);
    tbtnMode04.setIcon(this.iconMode04);
    tbtnMode05.setIcon(this.iconMode05);
    tbtnMode06.setIcon(this.iconMode06);
    tbtnMode07.setIcon(this.iconMode07);
    tbtnMode08.setIcon(this.iconMode08);
    tbtnMode09.setIcon(this.iconMode09);

    pnlSetup.setBorder(BorderFactory.createEtchedBorder());
    pnlSetup.setBounds(new Rectangle(489, 293, 207, 206));
    pnlSetup.setLayout(gridLayoutPnlSetup);

    chkShowFaces.setText(languages.getShowFacesLabel());
    chkShowFaces.addItemListener(new OtherOptions_ItemListener());
    chkShowEdges.setText(languages.getShowEdgesLabel());
    chkShowEdges.addItemListener(new OtherOptions_ItemListener());

    chkShowVertices.setText(languages.getShowVerticesLabel());
    chkShowVertices.addActionListener(new MatHSoliD_chkShowVertices_actionAdapter(this));
    chkShowVertices.addItemListener(new OtherOptions_ItemListener());

    chkEnableDepth.setText(languages.getEnableDepthLabel());
    chkEnableDepth.addItemListener(new OtherOptions_ItemListener());

    //chkEnableFit.setText(languages.getEnableDepthLabel());
    chkEnableFit.setText(languages.getEnableFit());
    chkEnableFit.setSelected(this.enableFit);
    chkEnableFit.addItemListener(new OtherOptions_ItemListener());

    chkEnableTransparency.setText(languages.getEnableTransparencyLabel());
    chkEnableTransparency.addChangeListener(new MatHSoliD_chkEnableTransparency_changeAdapter(this));
    chkEnableTransparency.addItemListener(new OtherOptions_ItemListener());

    btnResetCamera.setBounds(new Rectangle(716, 413, 125, 25));
    btnResetCamera.setText(languages.getResetCameraLabel());
    btnResetCamera.addActionListener(new MatHSoliD_btnResetCamera_actionAdapter(this));

    tbtnSetup.setFocusPainted(false);
    tbtnSetup.setText(languages.getViewOtherOptionsLabel());
    tbtnSetup.setBounds(new Rectangle(489, 266, 207, 22));
    //tbtnSetup.addActionListener(new MatHSoliD_tbtnSetup_actionAdapter(this));
    tbtnSetup.addItemListener(new MatHSoliD_tbtnSetup_itemAdapter(this));

    gridLayoutPnlSetup.setRows(10);

    cmbCategorySolids.setBounds(new Rectangle(489, 144, 207, 24));
    cmbCategorySolids.addItemListener(new MatHSoliD_cmbCategorySolids_itemAdapter(this));
    cmbCategorySolids.addActionListener(new
                                        MatHSoliD_cmbCategorySolids_actionAdapter(this));
    cmbCategorySolids.setPopupVisible(false);

    gridLayoutPnlToggleButtons.setRows(3);
    pnlBtnColors.setBorder(BorderFactory.createEtchedBorder());
    pnlBtnColors.setBounds(new Rectangle(489, 293, 207, 91));
    pnlBtnColors.setLayout(null);

    BtnColorTriangles.setBounds(new Rectangle(6, 7, 35, 35));
    BtnColorTriangles.setFocusPainted(false);
    BtnColorTriangles.setIcon(iconTriangle);
    BtnColorTriangles.setText("");
    BtnColorTriangles.addActionListener(new
                                        MatHSoliD_BtnColorTriangles_actionAdapter(this));
    BtnColorSquares.setBounds(new Rectangle(58, 7, 35, 35));
    BtnColorSquares.setFocusPainted(false);
    BtnColorSquares.setIcon(iconSquare);
    BtnColorSquares.setText("");
    BtnColorSquares.addActionListener(new MatHSoliD_BtnColorSquares_actionAdapter(this));
    BtnColorPentagon.setBounds(new Rectangle(111, 7, 35, 35));
    BtnColorPentagon.setFocusPainted(false);
    BtnColorPentagon.setIcon(iconPentagon);
    BtnColorPentagon.setText("");
    BtnColorPentagon.addActionListener(new
                                       MatHSoliD_BtnColorPentagon_actionAdapter(this));
    BtnColorHexagons.setBounds(new Rectangle(163, 7, 35, 35));
    BtnColorHexagons.setFocusPainted(false);
    BtnColorHexagons.setIcon(iconHexagon);
    BtnColorHexagons.setText("");
    BtnColorHexagons.addActionListener(new
                                       MatHSoliD_BtnColorHexagons_actionAdapter(this));
    BtnColorHeptagons.addActionListener(new
                                        MatHSoliD_BtnColorHeptagons_actionAdapter(this));
    BtnColorHeptagons.setText("");
    BtnColorHeptagons.setIcon(iconHeptagon);
    BtnColorHeptagons.setFocusPainted(false);
    BtnColorHeptagons.setBounds(new Rectangle(6, 48, 35, 35));
    BtnColorOctogons.setText("");
    BtnColorOctogons.addActionListener(new
                                       MatHSoliD_BtnColorOctogons_actionAdapter(this));
    BtnColorOctogons.setIcon(iconOctogon);
    BtnColorOctogons.setFocusPainted(false);
    BtnColorOctogons.setBounds(new Rectangle(58, 48, 35, 35));
    BtnColorEneagons.setText("");
    BtnColorEneagons.addActionListener(new
                                       MatHSoliD_BtnColorEneagons_actionAdapter(this));
    BtnColorEneagons.setIcon(iconEneagon);
    BtnColorEneagons.setFocusPainted(false);
    BtnColorEneagons.setBounds(new Rectangle(111, 48, 35, 35));
    BtnColorDecagons.addActionListener(new
                                       MatHSoliD_BtnColorDecagons_actionAdapter(this));
    BtnColorDecagons.setText("");
    BtnColorDecagons.setIcon(iconDecagon);
    BtnColorDecagons.setFocusPainted(false);
    BtnColorDecagons.setBounds(new Rectangle(163, 48, 35, 35));

    tbtnViewBtnColors.setSelected(false);
    tbtnViewBtnColors.setBounds(new Rectangle(489, 241, 207, 22));
    //tbtnViewBtnColors.addActionListener(new MatHSoliD_tbtnViewBtnColors_actionAdapter(this));
    tbtnViewBtnColors.addItemListener(new MatHSoliD_tbtnViewBtnColors_itemAdapter(this));
    tbtnViewBtnColors.setFocusPainted(false);
    tbtnViewBtnColors.setText(languages.getColorOfTheFaceLabel());

    sliderTransparency.setEnabled(false);
    sliderTransparency.addChangeListener(new MatHSoliD_sliderTransparency_changeAdapter(this));
    btnSave.setBounds(new Rectangle(18, 502, 108, 22));
    btnSave.setText("Save Picture");
    btnSave.addActionListener(new MatHSoliD_btnSave_actionAdapter(this));
    btnBgColorDisplay.addActionListener(new MatHSoliD_btnBgColorDisplay_actionAdapter(this));
    btnBgColorDisplay.setText(languages.getBackgroundColor());//////////////////////////////////////////

    btnCopyRight.setBounds(new Rectangle(453, 502, 31, 24));
    btnCopyRight.setBorder(null);
    btnCopyRight.setToolTipText("");
    btnCopyRight.setFocusPainted(false);
    btnCopyRight.setText("");
    btnCopyRight.addActionListener(new MatHSoliD_btnCopyRight_actionAdapter(this));
    chkAutoAnimation.setMinimumSize(new Dimension(40, 23));
    chkAutoAnimation.setFocusPainted(false);
    chkAutoAnimation.setText(languages.getAutoAnimation());
    chkAutoAnimation.setBounds(new Rectangle(489, 217, 140, 23));
    chkAutoAnimation.addActionListener(new MatHSoliD_chkAutoAnimation_actionAdapter(this));
    chkAutoAnimation.addItemListener(new MatHSoliD_chkAutoAnimation_itemAdapter(this));

    btnImage.setBounds(new Rectangle(490, 403, 206, 91));
    btnImage.setBorder(null);
    btnImage.setText("");
    btnImage.addActionListener(new MatHSoliD_btnImage_actionAdapter(this));
    btnImage.setIcon(this.imgLogo);

    lblRotationPerc.setHorizontalAlignment(SwingConstants.RIGHT);
    lblRotationPerc.setText("00");
    lblRotationPerc.setBounds(new Rectangle(626, 222, 67, 16));
    pnlToggleButtons.add(tbtnMode01, null);
    pnlToggleButtons.add(tbtnMode02, null);
    pnlToggleButtons.add(tbtnMode03, null);
    pnlToggleButtons.add(tbtnMode04, null);
    pnlToggleButtons.add(tbtnMode05, null);
    pnlToggleButtons.add(tbtnMode06, null);
    pnlToggleButtons.add(tbtnMode07, null);
    pnlToggleButtons.add(tbtnMode08, null);
    pnlToggleButtons.add(tbtnMode09, null);
    this.getContentPane().add(pnlSetup, null);

    btnGroup.add(tbtnMode01);
    btnGroup.add(tbtnMode02);
    btnGroup.add(tbtnMode03);
    btnGroup.add(tbtnMode04);
    btnGroup.add(tbtnMode05);
    btnGroup.add(tbtnMode06);
    btnGroup.add(tbtnMode07);
    btnGroup.add(tbtnMode08);
    btnGroup.add(tbtnMode09);

    pnlSetup.add(chkShowFaces, null);
    pnlSetup.add(chkShowEdges, null);
    pnlSetup.add(chkShowVertices, null);
    pnlSetup.add(chkEnableFit, null);
    pnlSetup.add(chkEnableDepth, null);
    pnlSetup.add(chkEnableTransparency, null);
    pnlSetup.add(sliderTransparency, null);
    pnlSetup.add(btnEdgeColor, null);
    pnlSetup.add(btnResetCamera, null);
    pnlSetup.add(btnBgColorDisplay, null);
    this.getContentPane().add(CmbSolids, null);
    this.getContentPane().add(chkAutoAnimation, null);
    this.getContentPane().add(sliderRotation, null);
    this.getContentPane().add(cmbCategorySolids, null);
    this.getContentPane().add(tbtnSetup, null);
    this.getContentPane().add(pnlBtnColors, null);
    pnlSetup.setVisible(false);
    /////////////////////////////////////////////////////////////////////////

    tbtnSetup.setSelected(false);
    tbtnViewBtnColors.setSelected(true);

    //tbtnMode01.setSelected(true);
    //this.tbtnMode01_actionPerformed(null);

    pnlBtnColors.add(BtnColorTriangles, null);
    pnlBtnColors.add(BtnColorOctogons, null);
    pnlBtnColors.add(BtnColorPentagon, null);
    pnlBtnColors.add(BtnColorEneagons, null);
    pnlBtnColors.add(BtnColorHeptagons, null);
    pnlBtnColors.add(BtnColorSquares, null);
    pnlBtnColors.add(BtnColorDecagons, null);
    pnlBtnColors.add(BtnColorHexagons, null);
    this.getContentPane().add(tbtnViewBtnColors, null);
    this.getContentPane().add(pnlToggleButtons, null);

    this.getContentPane().add(display, null);
    this.getContentPane().add(Cc1, null);
    this.getContentPane().add(lblRotationPerc, null);
    this.getContentPane().add(btnSave, null);
    this.getContentPane().add(btnCopyRight, null);
    this.getContentPane().add(btnImage, null);
    pnlBtnColors.setLocation(pnlSetup.getLocation());

    btnGroupBtnViewOptions.add(tbtnViewBtnColors);
    btnGroupBtnViewOptions.add(tbtnSetup);


    switch(this.indexVisual){
      case 1:
        tbtnMode01.setSelected(true);
        this.executeMode01();
        break;
      case 2:
        tbtnMode02.setSelected(true);
        this.executeMode02();
        break;
      case 3:
        tbtnMode03.setSelected(true);
        this.executeMode03();
        break;
      case 4:
        tbtnMode04.setSelected(true);
        this.executeMode04();
        break;
      case 5:
        tbtnMode05.setSelected(true);
        this.executeMode05();
        break;
      case 6:
        tbtnMode06.setSelected(true);
        this.executeMode06();
        break;
      case 7:
        tbtnMode07.setSelected(true);
        this.executeMode07();
        break;
      case 8:
        tbtnMode08.setSelected(true);
        this.executeMode08();
        break;
      default:
        tbtnMode01.setSelected(true);
        this.executeMode01();
        break;
    }//end switch


    //this.selectSolid(0, 0);
    if (this.isStandalone){
      this.btnSave.setVisible(true);
    }
    else{
      //this.selectSolid(0,0);
      this.btnSave.setVisible(false);
    }

    //Colors of the faces
    this.Colors[0]=Color.BLACK;
    this.Colors[1]=Color.BLACK;
    this.Colors[2]=Color.BLACK;
    this.Colors[3]=new Color(1.0f, 0.0f, 0.0f);
    this.Colors[4]=new Color(0.0f, 0.0f, 1.0f);
    this.Colors[5]=new Color(0.0f, 1.0f, 0.0f);
    this.Colors[6]=new Color(1.0f, 0.0f, 1.0f);
    this.Colors[7]=new Color(0.25f, 0.1f, 0.2f);
    this.Colors[8]=new Color(1.0f, 1.0f, 0.0f);
    this.Colors[9]=Color.DARK_GRAY;
    this.Colors[10]=Color.CYAN;

    this.CmbSolids.setSelectedItem(initialSolid);
    this.selectSolid(cmbCategorySolids.getSelectedIndex(), CmbSolids.getSelectedIndex());
    this.sliderRotation.setValue(this.percRotation);
    this.setEdgeThickness(this.edgeThickness);
    this.rotate();


  }





  //Start the applet
  public void start() {
  }

  //Stop the applet
  public void stop() {
  }

  //Destroy the applet
  public void destroy() {
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"language", "String", "The language for the user interface."},
      {"percRotation", "int", "The percentile of rotation of the faces of the initial solid."},
      {"initialSolid", "String", "The name of the solid that will be exhibited when the program be loaded."},
      {"backgroundColor", "String", "Background color of the display."},
      {"controlPanel", "boolean", "Set the visiability of the Control Panel"},
      {"indexVisual", "int", "Set the visualization mode."},
      };
    return pinfo;
  }

  //Main method
  public static void main(String[] args) {
    MatHSoliD applet = new MatHSoliD();
    applet.isStandalone = true;
    frame = new JFrame();

    frame.setDefaultCloseOperation(frame.DISPOSE_ON_CLOSE);
   //frame.setLocale(java.util.Locale.getDefault());
    frame.setState(Frame.NORMAL);
    frame.setTitle("MatHSoliD");

    //EXIT_ON_CLOSE == 3
    //frame.setDefaultCloseOperation(3);
    frame.getContentPane().add(applet, BorderLayout.CENTER);
    applet.manageViewer = new PvViewer(null,frame);
    applet.init();
    applet.start();
    frame.setSize(700,560);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
    frame.show();

  }

  private void setEdgeThickness(double thickness) {
    solid.setGlobalEdgeSize(thickness);
    solid.setGlobalVertexSize(thickness);
    //Atualiza o display
    display.update(solid);
  }


  //This method has the function of rotating the faces, in relation to its planning,
  //in agreement with the percentile supplied by the property Value of the sliderRotation.
  private void rotate() {
    Face currentFace = new Face();
    Position currentPosition;
    int currentVertexOfSolid = 0;
    int currentFaceOfSolid = 0;
    double perc = ( (double) sliderRotation.getValue()) / 100;

    spaceSolid.rotateSubFaces(perc);

    PreOrderIterator iter = new PreOrderIterator(spaceSolid);
    while (iter.hasNext()) {
      currentPosition = iter.nextPosition();
      currentFace = ( (Face) currentPosition.element());
      //Configura as coordenadas de cada vrtice
      for (int i = 0; i < currentFace.myCoordsVertices.getNumVertices(); i++)
        solid.getVertex(currentVertexOfSolid++).set(currentFace.myCoordsVertices.getVertex(i),0,3);
    }

    //Ajusta o slido no display
    if (this.chkEnableFit.isSelected())
      display.fit();
    //Atualiza o display
    display.update(solid);

    //Exibindo o percentual de rotaao
    java.text.DecimalFormat format = new java.text.DecimalFormat("00 %");
    String percString = format.format(perc);
    this.lblRotationPerc.setText(percString);
    //this.chkAutoAnimation.setText("   0");


  }

  private void updateColors(){
    for (int i=0; i<solid.getNumElements();i++){
      switch(solid.getElement(i).getSize()){
        case 3:
          //solid.setElementColor(i, new Color(1.0f, 0.0f, 0.0f));
          solid.setElementColor(i, this.Colors[3]);
          break;
        case 4:
          //solid.setElementColor(i, new Color(0.0f, 0.0f, 1.0f));
          solid.setElementColor(i, this.Colors[4]);
          break;
        case 5:
          //solid.setElementColor(i, new Color(0.0f, 1.0f, 0.0f));
          solid.setElementColor(i, this.Colors[5]);
          break;
        case 6:
          //solid.setElementColor(i, new Color(1.0f, 0.0f, 1.0f));
          solid.setElementColor(i, this.Colors[6]);
          break;
        case 7:
          //solid.setElementColor(i, new Color(0.25f, 0.1f, 0.2f));
          solid.setElementColor(i, this.Colors[7]);
          break;
        case 8:
          //solid.setElementColor(i, new Color(1.0f, 1.0f, 0.0f));
          solid.setElementColor(i, this.Colors[8]);
          break;
        case 9:
          //solid.setElementColor(i, new Color(1.0f, 1.0f, 0.0f));
          solid.setElementColor(i, this.Colors[9]);
          break;
        case 10:
          //solid.setElementColor(i, Color.CYAN);
          solid.setElementColor(i, this.Colors[10]);
          break;
      }
    }
    display.update(solid);
  }

  private void updateColors(int polygon, Color newColor){
    if (newColor==null) return;

    for(int i=0; i<solid.getNumElements(); i++){
      if(solid.getElement(i).getSize()==polygon)
        solid.setElementColor(i, newColor);
    }

    display.update(solid);
  }

  void sliderRotation_stateChanged(ChangeEvent e) {
    rotate();

  }


  private void updateColors(int polygon){
    Color newColor;
    newColor=this.Colors[polygon];
    if (newColor==null) return;

      for(int i=0; i<solid.getNumElements(); i++){
        if(solid.getElement(i).getSize()==polygon)
          solid.setElementColor(i, newColor);
      }

      display.update(solid);
    }


  private void configurateFaceOfTheSolid(){
    //Configura as faces do slido informando os ndices dos vrtices que formam uma face
    Face currentFace = new Face();
    Position currentPosition;
    int currentVertexOfSolid = 0;

    PreOrderIterator iter = new PreOrderIterator(spaceSolid);
    while (iter.hasNext()) {
      currentPosition = iter.nextPosition();
      currentFace = ( (Face) currentPosition.element());
      //Configura as coordenadas de cada vrtice

      currentVertexOfSolid += currentFace.getNumVertices();

      //Informa para o PgElementSet(solid) que os ltimos 'currentFace.getNumVertices()' vertices formam uma face
      PiVector verticesOfFaces = new PiVector();
      for (int i = currentVertexOfSolid - 1;
           i >= currentVertexOfSolid - currentFace.getNumVertices(); i--) {
        verticesOfFaces.addEntry(i);
      }
      //Configura a face
      solid.setElement(currentFace.myIndex, verticesOfFaces);
    }

  }

  private void selectSolid(String solidName){

    if(this.languages.isPlatonic(solidName)){
      this.cmbCategorySolids.setSelectedIndex(0);
    }
    else{
      if(this.languages.isArchimedean(solidName)){
        this.cmbCategorySolids.setSelectedIndex(1);
      }
      else{
        this.selectSolid(0,0);
        return;
      }
    }

    this.CmbSolids.setSelectedItem(solidName);
  }


  private void selectSolid(int indexCategory, int indexSolid){
    switch (indexCategory){
      case 0:
        switch (indexSolid) {
          case 0:
            solid.setNumVertices(12);
            solid.setNumElements(4);
            spaceSolid = PlatonicSolids.generateRegularTetrahedron();
            break;
          case 1:
            solid.setNumVertices(24);
            solid.setNumElements(6);
            spaceSolid = PlatonicSolids.generateCubeTree();
            break;
          case 2:
            solid.setNumVertices(24);
            solid.setNumElements(8);
            spaceSolid = PlatonicSolids.generateRegularOctahedron();
            break;
          case 3:
            solid.setNumVertices(60);
            solid.setNumElements(12);
            spaceSolid = PlatonicSolids.generateRegularDodecahedron();
            break;
          case 4:
            solid.setNumVertices(60);
            solid.setNumElements(20);
            spaceSolid = PlatonicSolids.generateRegularIcosahedron();
            break;
        }
      break;
      case 1:
        switch (indexSolid){
          case 0:
            solid.setNumVertices(36);
            solid.setNumElements(8);
            spaceSolid = ArchimedeanSolids.generateTruncatedTetrahedron();
            break;
          case 1:
            solid.setNumVertices(48);
            solid.setNumElements(14);
            spaceSolid = ArchimedeanSolids.generateCuboctahedron();
            break;
          case 2:
            solid.setNumVertices(72);
            solid.setNumElements(14);
            spaceSolid = ArchimedeanSolids.generateTruncatedCube();
            break;
          case 3:
            solid.setNumVertices(72);
            solid.setNumElements(14);
            spaceSolid = ArchimedeanSolids.generateTruncatedOctahedron();
            break;
          case 4:
            solid.setNumVertices(96);
            solid.setNumElements(26);
            spaceSolid = ArchimedeanSolids.generateRhombicuboctahedron();
            break;
          case 5:
            solid.setNumVertices(144);
            solid.setNumElements(26);
            spaceSolid = ArchimedeanSolids.generateRhombiTruncatedCuboctahedron();
            break;
          case 6:
            solid.setNumVertices(360);
            solid.setNumElements(62);
            spaceSolid = ArchimedeanSolids.generateRhombiTruncatedIcosidodecahedron();
            break;
          case 7:
            solid.setNumVertices(120);
            solid.setNumElements(32);
            spaceSolid = ArchimedeanSolids.generateIcosidodecahedron();
            break;
          case 8:
            solid.setNumVertices(240);
            solid.setNumElements(62);
            spaceSolid = ArchimedeanSolids.generateRhombicosidodecahedron();
            break;
          case 9:
            solid.setNumVertices(180);
            solid.setNumElements(32);
            spaceSolid = ArchimedeanSolids.generateTruncatedDodecahedron();
            break;
          case 10:
            solid.setNumVertices(180);
            solid.setNumElements(32);
            spaceSolid = ArchimedeanSolids.generateTruncatedIcosahedron();
            break;
          case 11:
            solid.setNumVertices(120);
            solid.setNumElements(38);
            spaceSolid = ArchimedeanSolids.generateSnubCuboctahedron();
            break;
          case 12:
            solid.setNumVertices(300);
            solid.setNumElements(92);
            spaceSolid = ArchimedeanSolids.generateSnubIcosidodecahedron();
            break;
        }
      break;
    }

    this.configurateFaceOfTheSolid();
    this.rotate();
    this.updateColors();
    display.fit();
    display.center();
    this.enableColorButtons();
  }

  void CmbSolids_itemStateChanged(ItemEvent e) {
    this.selectSolid(cmbCategorySolids.getSelectedIndex(), CmbSolids.getSelectedIndex());
  }

  void CmbSolids_actionPerformed(ActionEvent e) {  }

  void BtnColorTriangles_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.TRIANGLE]=cor;
    this.updateColors(Face.TRIANGLE);

    //this.updateColors(Face.TRIANGLE,cor);
  }

  void BtnColorSquares_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.SQUARE]=cor;
    this.updateColors(Face.SQUARE);

    //this.updateColors(Face.SQUARE,cor);
  }

  void BtnColorPentagon_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.PENTAGON]=cor;
    this.updateColors(Face.PENTAGON);

    //this.updateColors(Face.PENTAGON,cor);
  }

  void BtnColorHexagons_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.HEXAGON]=cor;
    this.updateColors(Face.HEXAGON);

    //this.updateColors(Face.HEXAGON,cor);
  }

  void btnEdgeColor_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);

    if(cor!=null){
      solid.setGlobalEdgeColor(cor);
      display.update(solid);
    }
  }

  private void DisableColorButtons(){
    this.BtnColorTriangles.setEnabled(false);
    this.BtnColorSquares.setEnabled(false);
    this.BtnColorPentagon.setEnabled(false);
    this.BtnColorHexagons.setEnabled(false);
    this.BtnColorHeptagons.setEnabled(false);
    this.BtnColorOctogons.setEnabled(false);
    this.BtnColorEneagons.setEnabled(false);
    this.BtnColorDecagons.setEnabled(false);
  }

  private void enableColorButtons(){
    this.DisableColorButtons();
    HashSet polygonsSet = spaceSolid.getTypeFaces();
    Iterator iter = polygonsSet.iterator();
    while(iter.hasNext()){
      int polygon = ((Integer) iter.next()).intValue();
      switch (polygon){
        case 3:
          this.BtnColorTriangles.setEnabled(true);
          break;
        case 4:
          this.BtnColorSquares.setEnabled(true);
          break;
        case 5:
          this.BtnColorPentagon.setEnabled(true);
          break;
        case 6:
          this.BtnColorHexagons.setEnabled(true);
          break;
        case 7:
          this.BtnColorHeptagons.setEnabled(true);
          break;
        case 8:
          this.BtnColorOctogons.setEnabled(true);
          break;
        case 9:
          this.BtnColorEneagons.setEnabled(true);
          break;
        case 10:
          this.BtnColorDecagons.setEnabled(true);
          break;
      }

    }

  }

  private void addRemoveItemListener(int opt){
    ItemListener iT[];

    if (opt==0){
      iT = chkShowFaces.getItemListeners();
      chkShowFaces.removeItemListener(iT[0]);

      iT = chkShowEdges.getItemListeners();
      chkShowEdges.removeItemListener(iT[0]);

      iT = chkEnableTransparency.getItemListeners();
      chkEnableTransparency.removeItemListener(iT[0]);

      iT = chkShowVertices.getItemListeners();
      chkShowVertices.removeItemListener(iT[0]);

      iT = chkEnableDepth.getItemListeners();
      chkEnableDepth.removeItemListener(iT[0]);
    }
    else{
      ItemListener itemListener = new OtherOptions_ItemListener();
      chkShowFaces.addItemListener(itemListener);
      chkShowEdges.addItemListener(itemListener);
      chkShowVertices.addItemListener(itemListener);
      chkEnableTransparency.addItemListener(itemListener);
      chkEnableDepth.addItemListener(itemListener);

    }
  }

  void tbtnMode02_actionPerformed(ActionEvent e) {
    this.executeMode02();
  }

  private void executeMode02() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(true);
    chkShowEdges.setSelected(true);
    chkEnableTransparency.setSelected(false);
    chkShowVertices.setSelected(false);
    chkEnableDepth.setSelected(false);
    addRemoveItemListener(1);

    solid.showVertices(false);
    solid.showElementColors(true);
    solid.showElements(true);
    display.showDepthcue(false);
    solid.showTransparency(false);
    solid.showEdges(true);
    display.update(solid);
  }

  void tbtnMode03_actionPerformed(ActionEvent e) {
    this.executeMode03();
  }

  private void executeMode03() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(true);
    chkShowEdges.setSelected(false);
    chkEnableTransparency.setSelected(false);
    chkShowVertices.setSelected(false);
    chkEnableDepth.setSelected(true);
    addRemoveItemListener(1);

    solid.showVertices(false);
    solid.showElementColors(true);
    solid.showElements(true);
    display.showDepthcue(true);
    solid.showTransparency(false);
    solid.showEdges(false);
    display.update(solid);
  }

  void tbtnMode01_actionPerformed(ActionEvent e) {
    this.executeMode01();
  }

  private void executeMode01() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(true);
    chkShowEdges.setSelected(true);
    chkEnableTransparency.setSelected(false);
    chkShowVertices.setSelected(false);
    chkEnableDepth.setSelected(true);
    addRemoveItemListener(1);

    solid.showVertices(false);
    solid.showElementColors(true);
    solid.showElements(true);
    display.showDepthcue(true);
    solid.showTransparency(false);
    solid.showEdges(true);
    display.update(solid);

  }

  void tbtnMode04_actionPerformed(ActionEvent e) {
    this.executeMode04();
  }

  private void executeMode04() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(false);
    chkShowEdges.setSelected(true);
    chkEnableTransparency.setSelected(false);
    chkShowVertices.setSelected(false);
    chkEnableDepth.setSelected(false);
    addRemoveItemListener(1);

    solid.showVertices(false);
    display.showDepthcue(false);
    solid.showTransparency(false);
    solid.showElementColors(true);
    solid.showElements(false);
    solid.showEdges(true);
    display.update(solid);
  }

  void tbtnMode05_actionPerformed(ActionEvent e) {
    this.executeMode05();
  }

  private void executeMode05() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(true);
    chkShowEdges.setSelected(true);
    chkEnableTransparency.setSelected(false);
    chkShowVertices.setSelected(false);
    chkEnableDepth.setSelected(false);
    addRemoveItemListener(1);

    solid.showVertices(false);
    solid.showElementColors(false);
    solid.showTransparency(false);
    solid.setGlobalElementColor(display.getBackgroundColor());
    solid.showElements(true);
    solid.showEdges(true);
    display.showDepthcue(false);
    display.update(solid);

  }

  void tbtnMode06_actionPerformed(ActionEvent e) {
    this.executeMode06();
  }

  private void executeMode06() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(false);
    chkShowEdges.setSelected(false);
    chkEnableTransparency.setSelected(false);
    chkShowVertices.setSelected(true);
    chkEnableDepth.setSelected(false);
    addRemoveItemListener(1);

    solid.showElementColors(false);
    solid.showElements(false);
    solid.showEdges(false);
    display.showDepthcue(false);
    solid.showTransparency(false);
    solid.setGlobalVertexSize(2.0);
    solid.setGlobalVertexColor(Color.WHITE);
    solid.showVertices(true);
    display.update(solid);

  }

  void tbtnMode07_actionPerformed(ActionEvent e) {
    this.executeMode07();
  }

  private void executeMode07() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(true);
    chkShowEdges.setSelected(false);
    chkEnableTransparency.setSelected(false);
    chkShowVertices.setSelected(true);
    chkEnableDepth.setSelected(false);
    addRemoveItemListener(1);

    solid.showElementColors(false);
    solid.setGlobalElementColor(display.getBackgroundColor());
    solid.showElements(true);
    solid.showEdges(false);
    display.showDepthcue(false);
    solid.showTransparency(false);
    solid.setGlobalVertexSize(2.0);
    solid.setGlobalVertexColor(Color.WHITE);
    solid.showVertices(true);
    display.update(solid);

  }

  void tbtnMode08_actionPerformed(ActionEvent e) {
    this.executeMode08();
  }

  private void executeMode08() {
    //Atualiza os checkboxes do pnlSetup
    addRemoveItemListener(0);
    chkShowFaces.setSelected(true);
    chkShowEdges.setSelected(true);
    chkEnableTransparency.setSelected(true);
    chkShowVertices.setSelected(false);
    chkEnableDepth.setSelected(true);
    addRemoveItemListener(1);

    solid.showElementColors(true);
    solid.showElements(true);
    solid.showEdges(true);
    display.showDepthcue(true);
    solid.showVertices(false);
    //solid.setTransparency(0.5);
    solid.showTransparency(true);
    //display.showEdgeAura(false);
    //display.showEdgesOnce(false);
    display.update(solid);

  }

  void btnResetCamera_actionPerformed(ActionEvent e) {
    sliderRotation.setValue(0);
    display.getCamera().setViewDir (new PdVector(0.0,0.0,1.0));
    display.getCamera().setRoll(0.0);
    display.fit();
    tbtnMode01.setSelected(false);
    display.update(solid);

  }

  private class Anim_MouseListener extends java.awt.event.MouseAdapter {
    AnimationTime ani = new AnimationTime();
    //public void mouseClicked(MouseEvent e){    }

    public void mousePressed(MouseEvent e){
      if(timer.isRunning())
        timer.stop();

      ani.setInitialTime(sliderRotation.getValue());
      //btnBgColorDisplay.setText(Long.toString(ani.initialValue));
    }

    public void mouseReleased(MouseEvent e){
      ani.setFinalTime(sliderRotation.getValue());

      if(ani.finalValue>=ani.initialValue)
        inc=1;
      else
        inc=-1;

      timer.setDelay((int)(ani.getValuePerMillisecond()));

      if (chkAutoAnimation.isSelected())
        timer.start();
    }

  }

  private class OtherOptions_ItemListener implements java.awt.event.ItemListener {
    public void itemStateChanged(ItemEvent e) {
      tbtnMode09.setSelected(true);
      if (e.getSource().equals(chkShowFaces)){
        if (chkShowFaces.isSelected())
          solid.showElements(true);
        else
          solid.showElements(false);
      }
      else if(e.getSource().equals(chkShowEdges)){
        if (chkShowEdges.isSelected())
          solid.showEdges(true);
        else
          solid.showEdges(false);
      }
      else if(e.getSource().equals(chkShowVertices)){
        if (chkShowVertices.isSelected())
          solid.showVertices(true);
        else
          solid.showVertices(false);
      }
      else if(e.getSource().equals(chkEnableFit)){
        if (chkEnableFit.isSelected()){
          MatHSoliD.this.display.fit();
          MatHSoliD.this.rotate();
          }
        //else
          //solid.showVertices(false);
      }
      else if(e.getSource().equals(chkEnableTransparency)){
        if (chkEnableTransparency.isSelected()){
          //solid.showTransparency(true);
          //sliderTransparency.setEnabled(true);
        }
        //else{
          //solid.showTransparency(false);
          //sliderTransparency.setEnabled(false);
        //}
      }
      else if(e.getSource().equals(chkEnableDepth)){
        if (chkEnableDepth.isSelected())
          display.showDepthcue(true);
        else
          display.showDepthcue(false);
      }

      display.update(solid);
    }
  }

  void cmbCategorySolids_actionPerformed(ActionEvent e) {

  }

  void cmbCategorySolids_itemStateChanged(ItemEvent e) {
    MatHSoliDLanguages languages = new MatHSoliDLanguages(this.appletLanguage);
    String[] platonicsSolids = languages.getPlatonicSolids();
    String[] archimedeanSolids = languages.getArchimedeanSolids();

    switch (cmbCategorySolids.getSelectedIndex()){
      case 0:
        this.CmbSolids.removeAllItems();
        for(int i=0; i<platonicsSolids.length; i++)
          this.CmbSolids.addItem(platonicsSolids[i]);
        break;
       case 1:
        this.CmbSolids.removeAllItems();
        for(int i=0; i< archimedeanSolids.length; i++)
          this.CmbSolids.addItem(archimedeanSolids[i]);
        break;
    }
  }

  void BtnColorHeptagons_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.HEPTAGON]=cor;
    this.updateColors(Face.HEPTAGON);
      //this.updateColors(Face.HEPTAGON,cor);
  }

  void BtnColorEneagons_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.ENEAGON]=cor;
    this.updateColors(Face.ENEAGON);

    //this.updateColors(Face.ENEAGON,cor);
  }

  void BtnColorOctogons_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.OCTAGON]=cor;
    this.updateColors(Face.OCTAGON);

    //this.updateColors(Face.OCTAGON,cor);
  }

  void BtnColorDecagons_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
    if(cor!=null)
      this.Colors[Face.DECAGON]=cor;
    this.updateColors(Face.DECAGON);

    //this.updateColors(Face.DECAGON,cor);
  }

  void chkShowVertices_actionPerformed(ActionEvent e) {

  }

  void tbtnViewBtnColors_itemStateChanged(ItemEvent e) {
    if(tbtnViewBtnColors.isSelected())
      pnlBtnColors.setVisible(true);
    else
      pnlBtnColors.setVisible(false);
    //tbtnSetup.setSelected(false);
  }

  void tbtnSetup_itemStateChanged(ItemEvent e) {
    //tbtnViewBtnColors.setSelected(false);
    if(tbtnSetup.isSelected())
      pnlSetup.setVisible(true);
    else
      pnlSetup.setVisible(false);
  }

  //static initializer for setting look & feel
  static {
    try {
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e) {
    }
  }


  void sliderTransparency_stateChanged(ChangeEvent e) {
    double transparency = (double) sliderTransparency.getValue()/100;
    solid.setTransparency(transparency);
    display.update(solid);

    //Exibindo o percentual de transparencia
    java.text.DecimalFormat format = new java.text.DecimalFormat("00 %");
    String percString = format.format(transparency);
    this.chkEnableTransparency.setText(this.languages.getEnableTransparencyLabel()+"   "+percString);


  }

  void chkEnableTransparency_stateChanged(ChangeEvent e) {
    sliderTransparency.setEnabled(chkEnableTransparency.isSelected());
    solid.showTransparency(chkEnableTransparency.isSelected());
    sliderTransparency_stateChanged(null);
  }

  void btnSave_actionPerformed(ActionEvent e) {
    String fileName = Utils.saveImage(this.frame);

    if (fileName==null)
      return;

    this.manageViewer.selectDisplay(display);
    try{
      this.manageViewer.export(manageViewer.EXPORT_GIF,fileName,800,-1);
    }
    catch (Exception exp){
      System.out.println(exp.toString());
    }
  }

  void btnBgColorDisplay_actionPerformed(ActionEvent e) {
    Color cor = Cc1.showDialog(this,"Select a color...", Color.WHITE);
      if(cor!=null){
        display.setBackgroundColor(cor);
        display.update(solid);
        if(this.tbtnMode05.isSelected())//Corrige as cores do slido caso esteja no Modo05
          this.executeMode05();

      }
  }

  void btnCopyRight_actionPerformed(ActionEvent e) {
    //InfoPanel info = new InfoPanel();
    //this.getContentPane().add(info,-1);
    //info.setVisible(true);

  }

  void chkAutoAnimation_itemStateChanged(ItemEvent e) {
    if(chkAutoAnimation.isSelected())
      timer.start();
    else
      if(timer.isRunning())
        timer.stop();
  }

  void chkAutoAnimation_actionPerformed(ActionEvent e) {

  }

  void btnImage_actionPerformed(ActionEvent e) {
    if (this.frame!=null) return;
    java.applet.AppletContext ap = this.getAppletContext();
    try {
      if (ap!=null)
        ap.showDocument(new java.net.URL("http://www.mat.puc-rio.br/~hjbortol/mathsolid/"),"_blank");
    }
    catch(java.net.MalformedURLException exp){
      System.out.println(exp.toString());
    }
  }

}//end class MatHSoliD

class MatHSoliD_sliderRotation_changeAdapter implements javax.swing.event.ChangeListener {
  MatHSoliD adaptee;

  MatHSoliD_sliderRotation_changeAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void stateChanged(ChangeEvent e) {
    adaptee.sliderRotation_stateChanged(e);
  }
}

class MatHSoliD_CmbSolids_itemAdapter implements java.awt.event.ItemListener {
  MatHSoliD adaptee;

  MatHSoliD_CmbSolids_itemAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.CmbSolids_itemStateChanged(e);
  }
}

class MatHSoliD_CmbSolids_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_CmbSolids_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.CmbSolids_actionPerformed(e);
  }
}

class MatHSoliD_btnEdgeColor_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_btnEdgeColor_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnEdgeColor_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode02_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode02_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode02_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode03_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode03_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode03_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode01_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode01_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode01_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode04_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode04_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode04_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode05_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode05_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode05_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode06_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode06_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode06_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode07_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode07_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode07_actionPerformed(e);
  }
}

class MatHSoliD_tbtnMode08_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnMode08_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.tbtnMode08_actionPerformed(e);
  }
}

class MatHSoliD_btnResetCamera_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_btnResetCamera_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnResetCamera_actionPerformed(e);
  }
}

class MatHSoliD_cmbCategorySolids_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_cmbCategorySolids_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cmbCategorySolids_actionPerformed(e);
  }
}

class MatHSoliD_cmbCategorySolids_itemAdapter implements java.awt.event.ItemListener {
  MatHSoliD adaptee;

  MatHSoliD_cmbCategorySolids_itemAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.cmbCategorySolids_itemStateChanged(e);
  }
}

class MatHSoliD_chkShowVertices_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_chkShowVertices_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.chkShowVertices_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorHeptagons_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorHeptagons_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorHeptagons_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorTriangles_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorTriangles_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorTriangles_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorSquares_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorSquares_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorSquares_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorPentagon_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorPentagon_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorPentagon_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorHexagons_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorHexagons_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorHexagons_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorOctogons_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorOctogons_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorOctogons_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorEneagons_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorEneagons_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorEneagons_actionPerformed(e);
  }
}

class MatHSoliD_BtnColorDecagons_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_BtnColorDecagons_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.BtnColorDecagons_actionPerformed(e);
  }
}

class MatHSoliD_tbtnViewBtnColors_itemAdapter implements java.awt.event.ItemListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnViewBtnColors_itemAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.tbtnViewBtnColors_itemStateChanged(e);
  }
}

class MatHSoliD_tbtnSetup_itemAdapter implements java.awt.event.ItemListener {
  MatHSoliD adaptee;

  MatHSoliD_tbtnSetup_itemAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.tbtnSetup_itemStateChanged(e);
  }
}

class MatHSoliD_sliderTransparency_changeAdapter implements javax.swing.event.ChangeListener {
  MatHSoliD adaptee;

  MatHSoliD_sliderTransparency_changeAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void stateChanged(ChangeEvent e) {
    adaptee.sliderTransparency_stateChanged(e);
  }
}

class MatHSoliD_chkEnableTransparency_changeAdapter implements javax.swing.event.ChangeListener {
  MatHSoliD adaptee;

  MatHSoliD_chkEnableTransparency_changeAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void stateChanged(ChangeEvent e) {
    adaptee.chkEnableTransparency_stateChanged(e);
  }
}

class MatHSoliD_btnSave_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_btnSave_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnSave_actionPerformed(e);
  }
}

class MatHSoliD_btnBgColorDisplay_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_btnBgColorDisplay_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnBgColorDisplay_actionPerformed(e);
  }
}

class MatHSoliD_btnCopyRight_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_btnCopyRight_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnCopyRight_actionPerformed(e);
  }
}

class MatHSoliD_chkAutoAnimation_itemAdapter implements java.awt.event.ItemListener {
  MatHSoliD adaptee;

  MatHSoliD_chkAutoAnimation_itemAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.chkAutoAnimation_itemStateChanged(e);
  }
}

class MatHSoliD_chkAutoAnimation_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_chkAutoAnimation_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.chkAutoAnimation_actionPerformed(e);
  }
}

class MatHSoliD_btnImage_actionAdapter implements java.awt.event.ActionListener {
  MatHSoliD adaptee;

  MatHSoliD_btnImage_actionAdapter(MatHSoliD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnImage_actionPerformed(e);
  }
}




