package ic;

import java.io.*;
import java.net.URL;


public class MatHSoliDLanguages {
    private String applicationLanguage = "english";
    private String [] categoryOfSolids = {"Platonic Solids", "Archimedean Solids"};
    private String [] platonicSolids = {"Regular Tetrahedron","Cube","Regular Octahedron",
        "Regular Dodecahedron","Regular Icosahedron"};
    private String [] archimedeanSolids = {"Truncated Tetrahedron",
        "Cuboctahedron","Truncated Cube","Truncated Octahedron","Rhombicuboctahedron",
        "RhombiTruncated Cuboctahedron", "RhombiTruncated Icosidodecahedron",
        "Icosidodecahedron","Rhombicosidodecahedron", "Truncated Dodecahedron",
        "Truncated Icosahedron", "Snub Cuboctahedron", "Snub Icosidodecahedron"};
    private String [] userInterfaceLabels = {"Color Of The Faces", "View Others Options", "Show Faces", "Show Edges", "Show Vertices",
        "Enable Depth", "Enable Transparency", "Color Of The Edges", "Reset Camera", "Background Color", "Animation"};
    private String enableFit = "Enable Fit";

  public MatHSoliDLanguages(String language) {
    if(!language.equals("english"))
      this.nameSolid(language);
  }

  public String[] getCategoryOfSolids(){
    return this.categoryOfSolids;
  }

  public String[] getPlatonicSolids(){
    return this.platonicSolids;
  }

  public String[] getArchimedeanSolids(){
    return this.archimedeanSolids;
  }

  public String getApplicationLanguage(){ return this.applicationLanguage;}
  public String getColorOfTheFaceLabel(){ return this.userInterfaceLabels[0];}
  public String getViewOtherOptionsLabel(){ return this.userInterfaceLabels[1];}
  public String getShowFacesLabel(){ return this.userInterfaceLabels[2];}
  public String getShowEdgesLabel(){ return this.userInterfaceLabels[3];}
  public String getShowVerticesLabel(){ return this.userInterfaceLabels[4];}
  public String getEnableDepthLabel(){ return this.userInterfaceLabels[5];}
  public String getEnableTransparencyLabel(){ return this.userInterfaceLabels[6];}
  public String getColorOfTheEdgesLabel(){ return this.userInterfaceLabels[7];}
  public String getResetCameraLabel(){ return this.userInterfaceLabels[8];}
  public String getBackgroundColor(){ return this.userInterfaceLabels[9];}
  public String getAutoAnimation(){ return this.userInterfaceLabels[10];}
  public String getEnableFit(){ return this.enableFit;}

  private InputStream lanFile(String path){
    InputStream u = MatHSoliDLanguages.class.getResourceAsStream(path);
    return u;
    /*Object u = new Object();
    try {
      u = MatHSoliDLanguages.class.getResourceAsStream(path);
    }
    catch(Exception exp){
      exp.printStackTrace();
    }
    return (InputStream)u;*/
  }

  private void nameSolid(String language){
    StringBuffer out = new StringBuffer("");
    String txt = "";
    try {
      //BufferedReader arq = new BufferedReader(new InputStreamReader(new FileInputStream(new File("languages.txt"))));
      //File arquivo =new File("languages.txt");

      //if (!arquivo.exists())
        //return;

      InputStream r = lanFile("languages.txt");
      BufferedReader arq = new BufferedReader(new InputStreamReader(r));
      //BufferedReader arq = new BufferedReader(new FileReader(arquivo));


      do {
        txt = arq.readLine();
        if (txt != null) {
          if (txt.startsWith("[" + language.trim().toUpperCase() + "]")) {
            do {
              txt = arq.readLine();
              if (txt != null) {
                txt = txt.trim();
                if (txt.startsWith("APPLICATION_LANGUAGE"))
                   this.applicationLanguage=this.extractValue(txt);
                else if (txt.startsWith("REGULAR_TETRAHEDRON"))
                  this.platonicSolids[0]=this.extractValue(txt);
                else if (txt.startsWith("CUBE"))
                  this.platonicSolids[1]=this.extractValue(txt);
                else if (txt.startsWith("REGULAR_OCTAHEDRON"))
                  this.platonicSolids[2]=this.extractValue(txt);
                else if (txt.startsWith("REGULAR_DODECAHEDRON"))
                  this.platonicSolids[3]=this.extractValue(txt);
                else if (txt.startsWith("REGULAR_ICOSAHEDRON"))
                  this.platonicSolids[4]=this.extractValue(txt);
               //Archimedean Solids
                else if (txt.startsWith("CUBOCTAHEDRON"))
                  this.archimedeanSolids[1]=this.extractValue(txt);
                else if (txt.startsWith("ICOSIDODECAHEDRON"))
                  this.archimedeanSolids[7]=this.extractValue(txt);
                else if (txt.startsWith("TRUNCATED_TETRAHEDRON"))
                  this.archimedeanSolids[0]=this.extractValue(txt);
                else if (txt.startsWith("TRUNCATED_CUBE"))
                  this.archimedeanSolids[2]=this.extractValue(txt);
                else if (txt.startsWith("TRUNCATED_OCTAHEDRON"))
                  this.archimedeanSolids[3]=this.extractValue(txt);
                else if (txt.startsWith("TRUNCATED_DODECAHEDRON"))
                  this.archimedeanSolids[9]=this.extractValue(txt);
                else if (txt.startsWith("TRUNCATED_ICOSAHEDRON"))
                  this.archimedeanSolids[10]=this.extractValue(txt);
                else if (txt.startsWith("RHOMBICUBOCTAHEDRON"))
                  this.archimedeanSolids[4]=this.extractValue(txt);
                else if (txt.startsWith("RHOMBICOSIDODECAHEDRON"))
                  this.archimedeanSolids[8]=this.extractValue(txt);
                else if (txt.startsWith("RHOMBITRUNCATED_CUBOCTAHEDRON"))
                  this.archimedeanSolids[5]=this.extractValue(txt);
                else if (txt.startsWith("RHOMBITRUNCATED_ICOSIDODECAHEDRON"))
                  this.archimedeanSolids[6]=this.extractValue(txt);
                else if (txt.startsWith("SNUB_CUBOCTAHEDRON"))
                  this.archimedeanSolids[11]=this.extractValue(txt);
                else if (txt.startsWith("SNUB_ICOSIDODECAHEDRON"))
                  this.archimedeanSolids[12]=this.extractValue(txt);
                else if (txt.startsWith("PLATONIC_SOLIDS"))
                  this.categoryOfSolids[0]=this.extractValue(txt);
                else if (txt.startsWith("ARCHIMEDEAN_SOLIDS"))
                  this.categoryOfSolids[1]=this.extractValue(txt);
                else if (txt.startsWith("COLOR_OF_THE_FACES"))
                  this.userInterfaceLabels[0]=this.extractValue(txt);
                else if (txt.startsWith("VIEW_OTHERS_OPTIONS"))
                  this.userInterfaceLabels[1]=this.extractValue(txt);
                else if (txt.startsWith("SHOW_FACES"))
                  this.userInterfaceLabels[2]=this.extractValue(txt);
                else if (txt.startsWith("SHOW_EDGES"))
                  this.userInterfaceLabels[3]=this.extractValue(txt);
                else if (txt.startsWith("SHOW_VERTICES"))
                  this.userInterfaceLabels[4]=this.extractValue(txt);
                else if (txt.startsWith("ENABLE_DEPTH"))
                  this.userInterfaceLabels[5]=this.extractValue(txt);
                else if (txt.startsWith("ENABLE_TRANSPARENCY"))
                  this.userInterfaceLabels[6]=this.extractValue(txt);
                else if (txt.startsWith("COLOR_OF_THE_EDGES"))
                  this.userInterfaceLabels[7]=this.extractValue(txt);
                else if (txt.startsWith("RESET_CAMERA"))
                  this.userInterfaceLabels[8]=this.extractValue(txt);
                else if (txt.startsWith("BACKGROUND_COLOR"))
                  this.userInterfaceLabels[9]=this.extractValue(txt);
                else if (txt.startsWith("AUTO_ANIMATION"))
                  this.userInterfaceLabels[10]=this.extractValue(txt);
                else if (txt.startsWith("ENABLE_FIT"))
                  this.enableFit=new String(this.extractValue(txt));
              }
            }while (!txt.startsWith("[END]"));
          }
        }
      }while (txt != null);
      arq.close();
    }
    catch (IOException exp){
      exp.printStackTrace();
    }

  }

  private String extractValue(String line){
    int begin = line.indexOf('=') + 1;
    return line.substring(begin).trim();
  }

  public boolean isPlatonic(String solidName){
    boolean retorno=false;

    for(int i=0; i<this.platonicSolids.length; i++)
      if(solidName.trim().toLowerCase().equals(this.platonicSolids[i].trim().toLowerCase()))
        retorno=true;

    return retorno;
  }

  public boolean isArchimedean(String solidName){
    boolean retorno=false;

    for(int i=0; i<this.archimedeanSolids.length; i++)
      if(solidName.trim().toLowerCase().equals(this.archimedeanSolids[i].trim().toLowerCase()))
        retorno=true;

    return retorno;
  }


}
