package ic;

import jdsl.core.ref.*;
import jdsl.core.api.*;
import jv.vecmath.*;

public class PlatonicSolids extends NodeTree {

  //Dihedral angles
  public static final double REGULAR_TETRAHEDRON = Math.PI-529*Math.PI/1350;
  public static final double CUBE = Math.PI/2;
  public static final double REGULAR_OCTAHEDRON = Math.PI-821*Math.PI/1350;
  public static final double REGULAR_DODECAHEDRON = Math.PI-3497*Math.PI/5400;
  public static final double REGULAR_ICOSAHEDRON = Math.PI-8291*Math.PI/10800;

  public PlatonicSolids() {
  }

  public static Face generateCubeTree(){
    Face cubeTree = new Face();
    Position tmp;
    double dihedralAngle = PlatonicSolids.CUBE;
   //Insere a face me
    Face mainFace = new Face(Face.SQUARE,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle, 0);
    cubeTree.replaceElement(cubeTree.root(),mainFace);

    //Insere a face 01 cuja me  a raiz
    Face subFace01 = new Face(Face.SQUARE,mainFace.getVertex(0),mainFace.getVertex(3),dihedralAngle, 1);
    //cubeTree.insertLastChild(cubeTree.root(),subFace01);
    tmp = cubeTree.returnPositionFace(0,cubeTree);
    cubeTree.insertLastChild(tmp,subFace01);

    //Insere a face 02 cuja me  a raiz
    Face subFace02 = new Face(Face.SQUARE,mainFace.getVertex(1),mainFace.getVertex(0),dihedralAngle, 2);
    tmp = cubeTree.returnPositionFace(0,cubeTree);
    cubeTree.insertLastChild(tmp,subFace02);

    //Insere a face 03 cuja me  a raiz
    Face subFace03 = new Face(Face.SQUARE,mainFace.getVertex(2),mainFace.getVertex(1),dihedralAngle, 3);
    tmp = cubeTree.returnPositionFace(0,cubeTree);
    cubeTree.insertLastChild(tmp,subFace03);

    //Insere a face 04 cuja me  a raiz
    Face subFace04 = new Face(Face.SQUARE,mainFace.getVertex(3),mainFace.getVertex(2),dihedralAngle, 4);
    tmp = cubeTree.returnPositionFace(0,cubeTree);
    cubeTree.insertLastChild(tmp,subFace04);

    //Insere a face 05 cuja me  a subface 04
    Face subFace05 = new Face(Face.SQUARE,subFace04.getVertex(3),subFace04.getVertex(2),dihedralAngle, 5);
    tmp = cubeTree.returnPositionFace(4,cubeTree);
    cubeTree.insertLastChild(tmp,subFace05);

    return cubeTree;
  }


  public static Face generateRegularIcosahedron(){
    double dihedralAngle = PlatonicSolids.REGULAR_ICOSAHEDRON;
    Face icosahedronTree = new Face();
    Position tmp;
   //Insere a face me
    Face mainFace = new Face(Face.TRIANGLE,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle, 0);
    icosahedronTree.replaceElement(icosahedronTree.root(),mainFace);
    //tmp = icosahedronTree.returnPositionFace(0,icosahedronTree);
    //icosahedronTree.insertLastChild(tmp,mainFace);

    //Insere a face 01 cuja me  a raiz
    Face subFace01 = new Face(Face.TRIANGLE,mainFace.getVertex(1),mainFace.getVertex(0),dihedralAngle, 1);
    //icosahedronTree.insertLastChild(icosahedronTree.root(),subFace01);
    tmp = icosahedronTree.returnPositionFace(0,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace01);

    //Insere a face 02 cuja me  a subface 01
    Face subFace02 = new Face(Face.TRIANGLE,subFace01.getVertex(2),subFace01.getVertex(1),dihedralAngle, 2);
    tmp = icosahedronTree.returnPositionFace(1,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace02);

    //Insere a face 03 cuja me  a subface 02
    Face subFace03 = new Face(Face.TRIANGLE,subFace02.getVertex(0),subFace02.getVertex(2),dihedralAngle, 3);
    tmp = icosahedronTree.returnPositionFace(2,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace03);

    //Insere a face 04 cuja me  a subface 03
    Face subFace04 = new Face(Face.TRIANGLE,subFace03.getVertex(2), subFace03.getVertex(1),dihedralAngle, 4);
    tmp = icosahedronTree.returnPositionFace(3,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace04);

    //Insere a face 05 cuja me  a subface 04
    Face subFace05 = new Face(Face.TRIANGLE,subFace04.getVertex(0),subFace04.getVertex(2),dihedralAngle, 5);
    tmp = icosahedronTree.returnPositionFace(4,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace05);

    //Insere a face 06 cuja me  a subface 01
    Face subFace06 = new Face(Face.TRIANGLE,subFace01.getVertex(0), subFace01.getVertex(2),dihedralAngle, 6);
    tmp = icosahedronTree.returnPositionFace(1,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace06);

    //Insere a face 07 cuja me  a subface 06
    Face subFace07 = new Face(Face.TRIANGLE,subFace06.getVertex(2),subFace06.getVertex(1),dihedralAngle, 7);
    tmp = icosahedronTree.returnPositionFace(6,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace07);

    //Insere a face 08 cuja me  a subface 07
    Face subFace08 = new Face(Face.TRIANGLE,subFace07.getVertex(0),subFace07.getVertex(2),dihedralAngle, 8);
    tmp = icosahedronTree.returnPositionFace(7,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace08);


    //Insere a face 09 cuja me  a raiz (subaface 0)
    Face subFace09 = new Face(Face.TRIANGLE,mainFace.getVertex(2), mainFace.getVertex(1),dihedralAngle, 9);
    tmp = icosahedronTree.returnPositionFace(0,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace09);

    //Insere a face 10 cuja me  a subface 09
    Face subFace10 = new Face(Face.TRIANGLE,subFace09.getVertex(2), subFace09.getVertex(1),dihedralAngle, 10);
    tmp = icosahedronTree.returnPositionFace(9,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace10);

    //Insere a face 11 cuja me  a subface 10
    Face subFace11 = new Face(Face.TRIANGLE,subFace10.getVertex(0), subFace10.getVertex(2),dihedralAngle, 11);
    tmp = icosahedronTree.returnPositionFace(10,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace11);

    //Insere a face 12 cuja me  a subface 09
    Face subFace12 = new Face(Face.TRIANGLE,subFace09.getVertex(0),subFace09.getVertex(2),dihedralAngle, 12);
    tmp = icosahedronTree.returnPositionFace(9,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace12);

    //Insere a face 13 cuja me  a subface 12
    Face subFace13 = new Face(Face.TRIANGLE,subFace12.getVertex(2),subFace12.getVertex(1),dihedralAngle, 13);
    tmp = icosahedronTree.returnPositionFace(12,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace13);

    //Insere a face 14 cuja me  a subface 13
    Face subFace14 = new Face(Face.TRIANGLE,subFace13.getVertex(0),subFace13.getVertex(2),dihedralAngle, 14);
    tmp = icosahedronTree.returnPositionFace(13,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace14);

    //Insere a face 15 cuja me  a subface 0 (raiz)
    Face subFace15 = new Face(Face.TRIANGLE,mainFace.getVertex(0),mainFace.getVertex(2),dihedralAngle, 15);
    tmp = icosahedronTree.returnPositionFace(0,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace15);

    //Insere a face 16 cuja me  a subface 15
    Face subFace16 = new Face(Face.TRIANGLE,subFace15.getVertex(0),subFace15.getVertex(2),dihedralAngle, 16);
    tmp = icosahedronTree.returnPositionFace(15,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace16);

    //Insere a face 17 cuja me  a subface 16
    Face subFace17 = new Face(Face.TRIANGLE,subFace16.getVertex(2), subFace16.getVertex(1),dihedralAngle, 17);
    tmp = icosahedronTree.returnPositionFace(16,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace17);

    //Insere a face 18 cuja me  a subface 15
    Face subFace18 = new Face(Face.TRIANGLE, subFace15.getVertex(2), subFace15.getVertex(1),dihedralAngle, 18);
    tmp = icosahedronTree.returnPositionFace(15,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace18);

    //Insere a face 19 cuja me  a subface 18
    Face subFace19 = new Face(Face.TRIANGLE,subFace18.getVertex(0),subFace18.getVertex(2),dihedralAngle, 19);
    tmp = icosahedronTree.returnPositionFace(18,icosahedronTree);
    icosahedronTree.insertLastChild(tmp,subFace19);

    return icosahedronTree;
  }

  public static Face generateRegularTetrahedron(){
    double dihedralAngle = PlatonicSolids.REGULAR_TETRAHEDRON;
    Face regularTetrahedronTree = new Face();
    Position tmp;
    //Insere a face me
    Face mainFace = new Face(Face.TRIANGLE,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle, 0);
    regularTetrahedronTree.replaceElement(regularTetrahedronTree.root(),mainFace);
    //tmp = icosahedronTree.returnPositionFace(0,icosahedronTree);
    //icosahedronTree.insertLastChild(tmp,mainFace);

    //Insere a face 01 cuja me  a raiz
    Face subFace01 = new Face(Face.TRIANGLE,mainFace.getVertex(1),mainFace.getVertex(0),dihedralAngle, 1);
    tmp = regularTetrahedronTree.returnPositionFace(0,regularTetrahedronTree);
    regularTetrahedronTree.insertLastChild(tmp,subFace01);

    //Insere a face 02 cuja me  a raiz
    Face subFace02 = new Face(Face.TRIANGLE,mainFace.getVertex(2),mainFace.getVertex(1),dihedralAngle, 2);
    tmp = regularTetrahedronTree.returnPositionFace(0,regularTetrahedronTree);
    regularTetrahedronTree.insertLastChild(tmp,subFace02);

    //Insere a face 03 cuja me  a raiz
    Face subFace03 = new Face(Face.TRIANGLE,mainFace.getVertex(0),mainFace.getVertex(2),dihedralAngle, 3);
    tmp = regularTetrahedronTree.returnPositionFace(0,regularTetrahedronTree);
    regularTetrahedronTree.insertLastChild(tmp,subFace03);

    return regularTetrahedronTree;
  }

  public static Face generateRegularDodecahedron(){
  double dihedralAngle = PlatonicSolids.REGULAR_DODECAHEDRON;
  Face dodecahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face mainFace = new Face(Face.PENTAGON,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle, 0);
  dodecahedronTree.replaceElement(dodecahedronTree.root(),mainFace);
  //tmp = dodecahedronTree.returnPositionFace(0,dodecahedronTree);
  //dodecahedronTree.insertLastChild(tmp,mainFace);

  //Insere a face 01 cuja me  a raiz
  Face subFace01 = new Face(Face.PENTAGON,mainFace.getVertex(0),mainFace.getVertex(4),dihedralAngle, 1);
  //dodecahedronTree.insertLastChild(dodecahedronTree.root(),subFace01);
  tmp = dodecahedronTree.returnPositionFace(0,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.PENTAGON,subFace01.getVertex(4),subFace01.getVertex(3),dihedralAngle, 2);
  tmp = dodecahedronTree.returnPositionFace(1,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface me
  Face subFace03 = new Face(Face.PENTAGON,mainFace.getVertex(1),mainFace.getVertex(0),dihedralAngle, 3);
  tmp = dodecahedronTree.returnPositionFace(0,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.PENTAGON,subFace03.getVertex(4), subFace03.getVertex(3),dihedralAngle, 4);
  tmp = dodecahedronTree.returnPositionFace(3,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.PENTAGON,subFace04.getVertex(3),subFace04.getVertex(2),dihedralAngle, 5);
  tmp = dodecahedronTree.returnPositionFace(4,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 0
  Face subFace06 = new Face(Face.PENTAGON,mainFace.getVertex(2), mainFace.getVertex(1),dihedralAngle, 6);
  tmp = dodecahedronTree.returnPositionFace(0,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.PENTAGON,subFace06.getVertex(4),subFace06.getVertex(3),dihedralAngle, 7);
  tmp = dodecahedronTree.returnPositionFace(6,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace07);

  //Insere a face 08 cuja me  a subface 0
  Face subFace08 = new Face(Face.PENTAGON,mainFace.getVertex(3),mainFace.getVertex(2),dihedralAngle, 8);
  tmp = dodecahedronTree.returnPositionFace(0,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace08);


  //Insere a face 09 cuja me  a subFace 8
  Face subFace09 = new Face(Face.PENTAGON,subFace08.getVertex(4), subFace08.getVertex(3),dihedralAngle, 9);
  tmp = dodecahedronTree.returnPositionFace(8,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace09);

  //Insere a face 10 cuja me  a subface 0
  Face subFace10 = new Face(Face.PENTAGON,mainFace.getVertex(4), mainFace.getVertex(3),dihedralAngle, 10);
  tmp = dodecahedronTree.returnPositionFace(0,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace10);

  //Insere a face 11 cuja me  a subface 10
  Face subFace11 = new Face(Face.PENTAGON,subFace10.getVertex(4), subFace10.getVertex(3),dihedralAngle, 11);
  tmp = dodecahedronTree.returnPositionFace(10,dodecahedronTree);
  dodecahedronTree.insertLastChild(tmp,subFace11);

  return dodecahedronTree;
  }

  public static Face generateRegularOctahedron(){
  double dihedralAngle = PlatonicSolids.REGULAR_OCTAHEDRON;
  Face octahedronTree = new Face();
  Position tmp;
  //Insere a face me
  Face mainFace = new Face(Face.TRIANGLE,new PdVector(0.0,0.0,0.0), new PdVector(5.0,0.0,0.0),dihedralAngle, 0);
  octahedronTree.replaceElement(octahedronTree.root(),mainFace);
  //tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  //octahedronTree.insertLastChild(tmp,mainFace);

  //Insere a face 01 cuja me  a raiz
  Face subFace01 = new Face(Face.TRIANGLE,mainFace.getVertex(2),mainFace.getVertex(1),dihedralAngle, 1);
  //octahedronTree.insertLastChild(octahedronTree.root(),subFace01);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace01);

  //Insere a face 02 cuja me  a subface 01
  Face subFace02 = new Face(Face.TRIANGLE,subFace01.getVertex(0),subFace01.getVertex(2),dihedralAngle, 2);
  tmp = octahedronTree.returnPositionFace(1,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace02);

  //Insere a face 03 cuja me  a subface me
  Face subFace03 = new Face(Face.TRIANGLE,mainFace.getVertex(0),mainFace.getVertex(2),dihedralAngle, 3);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace03);

  //Insere a face 04 cuja me  a subface 03
  Face subFace04 = new Face(Face.TRIANGLE,subFace03.getVertex(0), subFace03.getVertex(2),dihedralAngle, 4);
  tmp = octahedronTree.returnPositionFace(3,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace04);

  //Insere a face 05 cuja me  a subface 04
  Face subFace05 = new Face(Face.TRIANGLE,subFace04.getVertex(2),subFace04.getVertex(1),dihedralAngle, 5);
  tmp = octahedronTree.returnPositionFace(4,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace05);

  //Insere a face 06 cuja me  a subface 0
  Face subFace06 = new Face(Face.TRIANGLE,mainFace.getVertex(1), mainFace.getVertex(0),dihedralAngle, 6);
  tmp = octahedronTree.returnPositionFace(0,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace06);

  //Insere a face 07 cuja me  a subface 06
  Face subFace07 = new Face(Face.TRIANGLE,subFace06.getVertex(0),subFace06.getVertex(2),dihedralAngle, 7);
  tmp = octahedronTree.returnPositionFace(6,octahedronTree);
  octahedronTree.insertLastChild(tmp,subFace07);


  return octahedronTree;
  }


}//End of Class
