package ic;
import java.io.*;
import java.awt.*;
import javax.swing.*;

public class Utils {
  private static final String gifExtension = "gif";

  public static String getExtension(java.io.File f) {
    String ext = null;
    String s = f.getName();
    int i = s.lastIndexOf('.');

    if (i > 0 &&  i < s.length() - 1) {
      ext = s.substring(i+1).toLowerCase().trim();
    }
    return ext;
  }


  public static String saveImage(JFrame parent) {
    int retorno = 0, returnDialog=0;
    String ext="", fileName=null;
    File file;

    JFileChooser box = new JFileChooser();
    box.setDialogType(JFileChooser.SAVE_DIALOG);
    retorno=box.showSaveDialog(parent);
    file=box.getSelectedFile();

    if (retorno==box.APPROVE_OPTION){
      fileName=file.toString();
      ext = getExtension(file);
      if (ext==null)
        fileName=file.toString()+"."+gifExtension;
      else
        fileName=file.toString().substring(0,file.toString().length()-4)+"."+gifExtension;

      //Verificar possveis erros neste ponto
      if (file.exists() && ext.equals(gifExtension)){
        returnDialog=JOptionPane.showConfirmDialog(parent,"Overwrite file?","Save File...",JOptionPane.YES_NO_OPTION);
        if(returnDialog==JOptionPane.OK_OPTION){
          //Save with fileName
          return fileName;
        }
      }
    }
    return fileName;

    //this.setTitle(fileName);
  }

  public static Color getColor(String color) {
    String hexValues="0123456789ABCDEFabcdef";
    Color defaultColor = Color.BLACK;
    //String r, g, b;

    if(color.toLowerCase().trim().equals("black"))
      return Color.decode("#000000");
    else if(color.toLowerCase().trim().equals("silver"))
      return Color.decode("#C0C0C0");
    else if(color.toLowerCase().trim().equals("gray"))
      return Color.decode("#808080");
    else if(color.toLowerCase().trim().equals("white"))
      return Color.decode("#FFFFFF");
    else if(color.toLowerCase().trim().equals("maroon"))
      return Color.decode("#800000");
    else if(color.toLowerCase().trim().equals("red"))
      return Color.decode("#FF0000");
    else if(color.toLowerCase().trim().equals("purple"))
      return Color.decode("#800080");
    else if(color.toLowerCase().trim().equals("fuchsia"))
      return Color.decode("#FF00FF");
    else if(color.toLowerCase().trim().equals("green"))
      return Color.decode("#008000");
    else if(color.toLowerCase().trim().equals("lime"))
      return Color.decode("#00FF00");
    else if(color.toLowerCase().trim().equals("olive"))
      return Color.decode("#808000");
    else if(color.toLowerCase().trim().equals("yellow"))
      return Color.decode("#FFFF00");
    else if(color.toLowerCase().trim().equals("navy"))
      return Color.decode("#000080");
    else if(color.toLowerCase().trim().equals("blue"))
      return Color.decode("#0000FF");
    else if(color.toLowerCase().trim().equals("teal"))
      return Color.decode("#008080");
    else if(color.toLowerCase().trim().equals("aqua"))
      return Color.decode("#00FFFF");

    if(color.length()!=7){
      return defaultColor;
    }

    if (color.charAt(0)!='#')
      return defaultColor;

    boolean p=false;
    //Verifica a consistncia do valor hexadecimal informado.
    for (int i=1; i<color.length();i++){
      p=false;
      for(int j=0;j<hexValues.length();j++){
        if(color.charAt(i)==hexValues.charAt(j)){
          p=true;
          continue;
        }
      }
      if(!p){
        return defaultColor;
      }

    }

    //r=cor.substring(1,3); //Retorna a componente RED (em Notao Hexadeciaml) cujo valor em notaco decimal pertence a [0,255]
    //g=cor.substring(3,5); //Retorna a componente GREEN (em Notao Hexadeciaml) cujo valor em notaco decimal pertence a [0,255]
    //b=cor.substring(5,7); //Retorna a componente BLUE (em Notao Hexadeciaml) cujo valor em notaco decimal pertence a [0,255]

    //O mtodo decode retorna um objeto java.awt.Color decodificando a String que representa um valor inteiro Hexadecimal
    return Color.decode(color);

  }



}